Package: randRotation
Title: Random Rotation Methods for High Dimensional Data with Batch
        Structure
Version: 1.22.0
Authors@R: 
    person(given = "Peter",
           family = "Hettegger",
           role = c("aut", "cre"),
           email = "p.hettegger@gmail.com",
           comment = c(ORCID = "0000-0001-8557-588X"))
Description: A collection of methods for performing random rotations on high-dimensional, normally distributed data (e.g. microarray or RNA-seq data) with batch structure.
    The random rotation approach allows exact testing of dependent test statistics with linear models following arbitrary batch effect correction methods.
License: GPL-3
biocViews: Software, Sequencing, BatchEffect, BiomedicalInformatics,
        RNASeq, Preprocessing, Microarray, DifferentialExpression,
        GeneExpression, Genetics, MicroRNAArray, Normalization,
        StatisticalMethod
Encoding: UTF-8
RdMacros: Rdpack
Imports: methods, graphics, utils, stats, Rdpack (>= 0.7)
RoxygenNote: 7.2.3
Suggests: knitr, BiocParallel, lme4, nlme, rmarkdown, BiocStyle,
        testthat (>= 2.1.0), limma, sva
VignetteBuilder: knitr
URL: https://github.com/phettegger/randRotation
BugReports: https://github.com/phettegger/randRotation/issues
git_url: https://git.bioconductor.org/packages/randRotation
git_branch: RELEASE_3_22
git_last_commit: 4c9448f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 05:56:56 UTC; biocbuild
Author: Peter Hettegger [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-8557-588X>)
Maintainer: Peter Hettegger <p.hettegger@gmail.com>

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
options(digits = 4)

## ----eval=FALSE---------------------------------------------------------------
# if(!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("randRotation")

## ----message=FALSE------------------------------------------------------------
library(randRotation)
set.seed(0)
# Dataframe of phenotype data (sample information)
pdata <- data.frame(batch = as.factor(rep(1:3, c(10,10,10))),
                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 1000

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

xtabs(data = pdata)

## -----------------------------------------------------------------------------
mod1 <- model.matrix(~1+phenotype, pdata)
head(mod1)

## -----------------------------------------------------------------------------
rr <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)

## -----------------------------------------------------------------------------
statistic <- function(Y, batch, mod){
  # (I) Batch effect correction with "Combat" from the "sva" package
  Y <- sva::ComBat(dat = Y, batch = batch, mod = mod)
  
  # (II) Linear model fit
  fit1 <- limma::lmFit(Y, design = mod)
  fit1 <- limma::eBayes(fit1)
  abs(fit1$t[,2])
}

## ----message=FALSE, results='hide'--------------------------------------------
rs1 <- rotateStat(initialised.obj = rr, R = 10, statistic = statistic,
                   batch = pdata$batch, mod = mod1)

## -----------------------------------------------------------------------------
rs1

## -----------------------------------------------------------------------------
p.vals <- pFdr(rs1)
hist(p.vals, col = "lightgreen");abline(h = 100, col = "blue", lty = 2)
qqunif(p.vals)

## -----------------------------------------------------------------------------
library(limma)
library(sva)

edata.combat <- ComBat(dat = edata, batch = pdata$batch, mod = mod1)
fit1 <- lmFit(edata.combat, mod1)
fit1 <- eBayes(fit1)

# P-values from t-statistics
p.vals.nonrot <- topTable(fit1, coef = 2, number = Inf, sort.by="none")$P.Value

hist(p.vals.nonrot, col = "lightgreen");abline(h = 100, col = "blue", lty = 2)
qqunif(p.vals.nonrot)
plot(p.vals, p.vals.nonrot, log = "xy", pch = 20)
abline(0,1, col = 4, lwd = 2)

## -----------------------------------------------------------------------------
# Specification of the full model
mod1 <- model.matrix(~1+phenotype, pdata)

# We select "phenotype" as the coefficient associated with H0
# All other coefficients are considered as "determined" coefficients
rr <- initRandrot(Y = edata, X = mod1, coef.h = 2)

coefs <- function(Y, mod){
  t(coef(lm.fit(x = mod, y = t(Y))))
}

# Specification of the H0 model
mod0 <- model.matrix(~1, pdata)

coef01 <- coefs(edata, mod0)
coef02 <- coefs(randrot(rr), mod0)

head(cbind(coef01, coef02))

all.equal(coef01, coef02)

## -----------------------------------------------------------------------------
coef11 <- coefs(edata, mod1)
coef12 <- coefs(randrot(rr), mod1)

head(cbind(coef11, coef12))

## -----------------------------------------------------------------------------
mod2 <- mod1
mod2[,2] <- mod2[,2] - 0.5

coef11 <- coefs(edata, mod2)
coef12 <- coefs(randrot(rr), mod2)

head(cbind(coef11, coef12))

## ----message=FALSE, results='hold'--------------------------------------------
library(limma)

mod1 = model.matrix(~phenotype, pdata)

## -----------------------------------------------------------------------------
# Linear model fit
fit0 <- lmFit(edata, mod1)
fit0 <- eBayes(fit0)

# P values for phenotype coefficient
p0 <- topTable(fit0, coef = 2, number = Inf, adjust.method = "none",
               sort.by = "none")$P.Value
hist(p0, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p0)

## -----------------------------------------------------------------------------
library(sva)
edata.combat = ComBat(edata, batch = pdata$batch, mod = mod1)

## -----------------------------------------------------------------------------
# Linear model fit
fit1 <- lmFit(edata.combat, mod1)
fit1 <- eBayes(fit1)

# P value for phenotype coefficient
p.combat <- topTable(fit1, coef = 2, number = Inf, adjust.method = "none",
                     sort.by = "none")$P.Value
hist(p.combat, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.combat)

## -----------------------------------------------------------------------------
init1 <- initBatchRandrot(edata, mod1, coef.h = 2, batch = pdata$batch)

## -----------------------------------------------------------------------------
statistic <- function(Y, batch, mod, coef){
  Y.tmp <- sva::ComBat(dat = Y, batch = batch, mod = mod)

  fit1 <- limma::lmFit(Y.tmp, mod)
  fit1 <- limma::eBayes(fit1)
  # The "abs" is needed for "pFdr" to calculate 2-tailed statistics
  abs(fit1$t[,coef])
}

## ----message=FALSE, results='hide'--------------------------------------------
res1 <- rotateStat(initialised.obj = init1, R = 10, statistic = statistic,
                   batch = pdata$batch, mod = mod1, coef = 2)

## -----------------------------------------------------------------------------
p.rot <- pFdr(res1)
head(p.rot)

hist(p.rot, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.rot)

## -----------------------------------------------------------------------------
plot(density(log(p.rot/p0)), col = "salmon", "Log p ratios",
     panel.first = abline(v=0, col = "grey"),
     xlim = range(log(c(p.rot/p0, p.combat/p0))))
lines(density(log(p.combat/p0)), col = "blue")
legend("topleft", legend = c("log(p.combat/p0)", "log(p.rot/p0)"),
       lty = 1, col = c("blue", "salmon"))

## -----------------------------------------------------------------------------
plot(p0, p.combat, log = "xy", pch = 20, col = "lightblue", ylab = "")
points(p0, p.rot, pch = 20, col = "salmon")
abline(0,1, lwd = 1.5, col = "black")
legend("topleft", legend = c("p.combat", "p.rot"), pch = 20,
       col = c("lightblue", "salmon"))

## -----------------------------------------------------------------------------
plot(density(log(p.combat/p.rot)), col = "blue",
     main = "log(p.combat / p.rot )", panel.first = abline(v=0, col = "grey"))

## -----------------------------------------------------------------------------
fdr.q  <- pFdr(res1, "fdr.q")
fdr.qu <- pFdr(res1, "fdr.qu")
fdr.BH <- pFdr(res1, "BH")

FDRs <- cbind(fdr.q, fdr.qu, fdr.BH)
ord1 <- order(res1$s0, decreasing = TRUE)

FDRs.sorted <- FDRs[ord1,]

matplot(FDRs.sorted, type = "l", lwd = 2)
legend("bottomright", legend = c("fdr.q", "fdr.qu", "BH"), lty = 1:5, lwd = 2,
       col = 1:6)

head(FDRs.sorted)


## ----warning=FALSE------------------------------------------------------------
edata[,] <- rnorm(length(edata))
group <- as.factor(rep(1:3, 10))

# add group effect for the first 100 features
group.effect <- rep(c(0,0,1), 10)
edata[1:100,] <- t(t(edata[1:100,]) + group.effect)

mod.groups <- model.matrix(~ group)

contrasts1 <- limma::makeContrasts("2vs3" = group2 - group3,
                                   levels = mod.groups)
contrasts1

## -----------------------------------------------------------------------------
mod.cont <- contrastModel(X = mod.groups, C = contrasts1)

## -----------------------------------------------------------------------------
init1 <- initBatchRandrot(edata, mod.cont, batch = pdata$batch)

## ----message=FALSE, results='hide', warning=FALSE-----------------------------
statistic <- function(Y, batch, mod, cont){
  Y.tmp <- sva::ComBat(dat = Y, batch = batch, mod = mod)

  fit1 <- limma::lmFit(Y.tmp, mod)
  
  fit1 <- limma::contrasts.fit(fit1, cont)
  fit1 <- limma::eBayes(fit1)
  
  # The "abs" is needed for "pFdr" to calculate 2-tailed statistics
  abs(fit1$t[,1])
}

res1 <- rotateStat(initialised.obj = init1, R = 20, statistic = statistic,
                   batch = pdata$batch, mod = mod.groups, cont = contrasts1)

## -----------------------------------------------------------------------------
p.rot <- pFdr(res1)
head(p.rot)

hist(p.rot, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.rot)

## -----------------------------------------------------------------------------
plot(density(res1$s0), main = "", ylim = c(0,1), col = 2)
lines(density(res1$stats[[1]]), col = 1)
legend("topright", col = 1:2, lty = 1,
       legend = c("null-distribution by rotation", "test statistic"))

## ----message=FALSE, results='hide', warning=FALSE-----------------------------
res2 <- rotateStat(initialised.obj = init1, R = 20, statistic = statistic,
                   batch = pdata$batch, mod = mod.groups, cont = contrasts1)

p.rot2 <- pFdr(res2)

plot(density(res2$s0), main = "", ylim = c(0,1), col = 2)
lines(density(res2$stats[[1]]), col = 1)
legend("topright", col = 1:2, lty = 1,
       legend = c("null-distribution by rotation", "test statistic"))

## -----------------------------------------------------------------------------
plot(p.rot, p.rot2, pch = 19, log = "xy")
abline(0,1, col = "red")

## -----------------------------------------------------------------------------
pdata$individual <- sort(c(1:15, 1:15))
colnames(pdata)[2] <- "tissue"
pdata$tissue <- c("Control", "Cancer")
pdata

## -----------------------------------------------------------------------------
edata[,] <- rnorm(length(edata))
for(i in seq(1,ncol(edata),2)){
  tmp1 <- rnorm(nrow(edata))
  edata[,i] <- edata[,i] + tmp1
  edata[,i+1] <- edata[,i+1] + tmp1
}

## -----------------------------------------------------------------------------
library(nlme)
df1 <- data.frame(pdata, d1 = edata[1,])
spl1 <- split(1:nrow(pdata), pdata$batch)

covs1 <- function(., df1, i){
  df1$d1 <- .

  me1 <- lme(d1 ~ tissue, data = df1[i,], random = ~1|individual)
  getVarCov(me1, type = "marginal")[[1]]
}

covs1 <- sapply(spl1,
                function(samps)rowMeans(apply(edata, 1, covs1, df1, samps)))
cov1 <- matrix(rowMeans(covs1), 2, 2)
cormat <- cov2cor(cov1)
cormat

## -----------------------------------------------------------------------------
cormat <-  diag(5) %x% cormat
cormat <- list(cormat, cormat, cormat)

mod1 <- model.matrix(~1+tissue, pdata)
rr1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch,
                        cormat = cormat)

statistic <- function(Y, batch, mod, df1){
  # Batch effect correction
  Y <- limma::removeBatchEffect(Y, batch = batch, design = mod)
  
  apply(Y, 1, function(j){
    df1$d1 <- j
    me0 <- nlme::lme(d1 ~ 1, data = df1, random = ~1|individual, method = "ML")
    me1 <- nlme::lme(d1 ~ tissue, data = df1, random = ~1|individual, method = "ML")
    
    abs(coef(me1)[1,2] / (sqrt(vcov(me1)[2,2])))
  })
  
}

rs1 <- rotateStat(initialised.obj = rr1, R = 4, statistic = statistic, 
                  batch = pdata$batch, mod = mod1, df1 = df1, parallel = TRUE)

p1 <- pFdr(rs1)

hist(p1, freq = FALSE); abline(h = 1, lty = 2, lwd = 2, col = "blue")
qqunif(p1)

## -----------------------------------------------------------------------------
sessionInfo()

#' @details
#' Please refer to the package vignette for further details on usage and for
#' a "quick start". \code{\link[randRotation:rotateStat]{rotateStat}} is
#' the central function of the package. Methods are described in
#' \insertCite{Hettegger2021}{randRotation}.
#' @importFrom Rdpack reprompt
#' @references \insertAllCited{}
"_PACKAGE"




#' Decomposition of the design matrix for random rotation generation
#'
#' Full QR decomposition of the design matrix \code{X}. No argument checks are
#' performed, see \code{Details}.
#'
#' @param X Design matrix as generated by
#'   \code{\link[stats:model.matrix]{model.matrix}}.
#' @param coef.d Non-\code{H0} coefficients.
#'
#' @return A \code{\link[base:list]{list}} object containing matrices \code{Xd},
#'   \code{Xhe} and rank of the qr decomposition.
#' @export
#'
#' @details The design matrix \code{X} is QR decomposed into \code{X = Xq Xr}.
#' By performing a full QR decomposition, \code{Xq} is automatically extended to
#' a full basis. \code{Xq} is further split into \code{Xd} and \code{Xhe}, where
#' \code{Xd} corresponds to columns \code{coef.d} (non-\code{H0} or
#' non-Null-Hypothesis columns) and \code{Xhe} correspond to all other columns
#' (\code{H0} and error columns), see \code{\link[randRotation:initRandrot]{initRandrot}}.
#' No argument checks are performed for reasons
#' of performance as this function is called frequently by
#' \code{\link[randRotation:initRandrot]{initRandrot}} when weights are used.
#' See \insertCite{Hettegger2021}{randRotation} and \insertCite{Langsrud2005}{randRotation} for further details.
#'
#' @references \insertAllCited{}
#' @author Peter Hettegger
#' @examples
#' design <- cbind(1, rep(0:1, 5))
#' X_decomp(design)

X_decomp <- function(X = NULL, coef.d = seq_len(ncol(X)-1))
{
  qrX <- qr(X)
  Xq <- qr.Q(qrX, complete = TRUE)

  list(Xd = Xq[, coef.d, drop = FALSE],
       Xhe = Xq[, setdiff(seq_len(ncol(Xq)), coef.d), drop = FALSE],
       rank = qrX$rank)
}


initRandrot <- function(Y = NULL, X = NULL, coef.h = NULL, weights = NULL,
                        cormat = NULL)
{

  if(is.null(X)) stop("Please specify X")
  if(any(dim(X) < 1)) stop("Dimensions of X (design matrix) invalid")
  if(is.null(Y) || ncol(Y) != nrow(X))
    stop("Number of rows in X (design matrix) and number of columns in Y do not match")

  if(is.null(coef.h)){
    if(!is.null(attr(X, "coef.h"))){
      coef.h <- attr(X, "coef.h")
    } else {
      coef.h <- seq_len(ncol(X))
    }
  }
  if(length(coef.h) < 1) stop("length(coef.h) must be at least 1")
  if(length(coef.h) == 1 && coef.h == -1) coef.h = NULL
  if(!is.null(coef.h) && !all(coef.h %in% seq_len(ncol(X))))
    stop("coef.h not contained in X (design matrix)")


  if(is.null(colnames(X))) colnames(X) <- seq_len(ncol(X))

  if(nrow(X) != ncol(Y)) stop("nrow(X) must match ncol(Y)")

  if(any(is.na(Y)))
    warning("Missing values found in Y. Missing values are tolerated as much as possible, but should be avoided. See \"initRandrot\" help page.")
  if(any(is.na(X)))
    warning("Missing values found in X. Missing values are tolerated as much as possible, but should be avoided. See \"initRandrot\" help page.")
  if(any(is.na(weights)))
    warning("Missing values found in weights. Missing values are tolerated as much as possible, but should be avoided. See \"initRandrot\" help page.")
  if(any(is.na(cormat)))
    warning("Missing values found in cormat. Missing values are tolerated as much as possible, but should be avoided. See \"initRandrot\" help page.")


  coef.h <- sort(coef.h)
  coef.d <- setdiff(seq_len(ncol(X)), coef.h)
  if(length(coef.d > 0) && length(coef.h > 0) && (min(coef.h) < max(coef.d))){
    message("coef.h ", ifelse(length(coef.d)==1, "does", "do"), " not correspond to the last columns in the design matrix.\nColumns of design matrix are rearranged.")
    X <- X[, c(coef.d, coef.h), drop = FALSE]
    coef.d <- seq_len(length(coef.d))
    coef.h <- seq_len(length(coef.h)) + length(coef.d)
  }

  rank.xd <- qr(X[,coef.d])$rank
  if(rank.xd < length(coef.d)){
    coef.d <- seq_len(qr(X[,coef.d])$rank)
    warning("Partitioned design matrix X[,coef.d] does not have full rank, see ?initRandrot.")
  }


  # Cholesky factorisation of correlationmatrix for whitening transformation
  if(!is.null(cormat)){
    if(any(abs(cormat) > 1) | !isSymmetric(cormat))
      stop("cormat has elements >1, < -1 and/or is not symmetric")
    if(ncol(cormat) != nrow(X))
      stop("Dimensions of cormat must match sample size")
    if(all(abs(cormat[upper.tri(cormat),drop = FALSE]) < 1e-10))
      warning("all off-diagonal entries of cormat are < 1e-10 or > -1e-10")
    if(!all(diag(cormat) == 1))
      stop("Correlation matrix must have 1s in the diagonal.")

    ### cormat = t(tcholC) %*% tcholC, to be in usual naming convention of
    ### cholesky decomposition (x = LL')
    tcholC <- chol(cormat)
    cholCinv <- drop(forwardsolve(t(tcholC), diag(ncol(tcholC))))
    tcholC <- drop(tcholC)
  } else {
    tcholC <- NULL
    cholCinv <- NULL
  }


  if(!is.null(weights)) {
    warning("Dependence structure is not generally preserved if weights are used (see ?pFdr).")
    return(
      initRandrotW(Y = Y, X = X, coef.h = coef.h, coef.d = coef.d,
                   weights = weights, cormat = cormat, cholCinv = cholCinv,
                   tcholC = tcholC))
  }

  #### (Whitening) transformation of X and Y
  if(!is.null(cormat)){
    Y.w <- Y %*% t(cholCinv)
    X.w <- cholCinv %*% X
  } else {
    Y.w <- Y
    X.w <- X
  }

  #### QR-decomposition of X
  decomp <- X_decomp(X.w, coef.d)

  if(ncol(decomp$Xhe) < 1) warning("Dimension of random rotation matrix is 0x0.")
  if(ncol(decomp$Xhe) == 1) warning("Dimension of random rotation matrix is 1x1.")

  Yd <- Y.w %*% decomp$Xd %*% t(decomp$Xd)
  dimnames(Yd) <- dimnames(Y)

  Xhe.Y.w <- t(decomp$Xhe) %*% t(Y.w)

  new("initRandrot", list(X = X, Xhe.Y.w = Xhe.Y.w, Yd = Yd, Xhe = decomp$Xhe,
                           coef.d = coef.d, coef.h = coef.h, cormat = cormat,
                           tcholC = tcholC, rank = decomp$rank))
}

#' Internal function
#'
#' @inheritParams initRandrot
#' @param coef.d Determined coefficients. These are all other coefficients that
#'   are not hypothesis coefficients (see also
#'   \code{\link[randRotation:initRandrot]{initRandrot}}).
#' @param cholCinv Inverse of the Cholesky factorisation of \code{cormat}.
#' @param tcholC Transposed of the Cholesky factorisation of \code{cormat}.
#'
#' @return An initialised
#'   \code{\link[randRotation:initRandrot-class]{initRandrotW}} object.
#' @author Peter Hettegger
#' @keywords internal
#' @examples
#' # For further examples see '?rotateStat' and package vignette.
#'
#' #set.seed(0)
#'
#' # Dataframe of phenotype data (sample information)
#' # We simulate 2 sample classes processed in 3 batches
#' pdata <- data.frame(phenotype = rep(c("Control", "Cancer"), c(5,5)))
#' features <- 100
#'
#' # Matrix with random gene expression data
#' edata <- matrix(rnorm(features * nrow(pdata)), features)
#' rownames(edata) <- paste("feature", 1:nrow(edata))
#'
#' mod1 <- model.matrix(~phenotype, pdata)
#'
#' ### Simulate weights
#' weights <- matrix(rbeta(features * nrow(pdata), 2, 2)+0.1, features)
#'
#' # Initialisation of the random rotation class
#' init1 <- initRandrot(Y = edata, X = mod1, coef.h = 2,
#'                         weights = weights)
#' init1
initRandrotW <- function(Y, X, coef.h, coef.d, weights, cormat,
                           cholCinv, tcholC)
{
  if(any(weights <= 0) | any(!is.finite(weights)))
    stop("Weights must be finite > 0")
  if(!all(dim(weights) == dim(Y)))
    stop("Y and weights must have equal dimensions.")

  w <- sqrt(weights)



  #### (Whitening) transformation of Y and X and QR-decomposition of X
  if(!is.null(cormat)){
    Y.w <- (w * Y) %*% t(cholCinv)

    decomp.list <- apply(w, 1, function(w.i){
      X_decomp(cholCinv %*% (w.i * X), coef.d)
    })
  } else {
    Y.w <- (w * Y)

    decomp.list <- apply(w, 1, function(w.i){
      X_decomp(w.i * X, coef.d)
    })
  }


  Yd <- t(vapply(seq_len(nrow(Y.w)), function(i){
    Y.w[i,,drop = FALSE] %*% decomp.list[[i]]$Xd %*% t(decomp.list[[i]]$Xd)
  }, numeric(ncol(Y.w))))

  dimnames(Yd) <- dimnames(Y)

  Xhe.Y.w <- vapply(seq_len(nrow(Y.w)), function(i){
    if(ncol(decomp.list[[i]]$Xhe) < 1)
      warning(paste0("Feature ", i, ": Dimension of random rotation matrix is 0x0."))
    if(ncol(decomp.list[[i]]$Xhe) == 1)
      warning(paste0("Feature ", i, ": Dimension of random rotation matrix is 1x1."))

    Y.w[i,,drop = FALSE] %*% decomp.list[[i]]$Xhe
  }, numeric(ncol(Y.w)-length(coef.d)))

  new("initRandrotW", list(X = X, Xhe.Y.w = Xhe.Y.w, Yd = Yd,
                             decomp.list = decomp.list, coef.d = coef.d,
                             coef.h = coef.h, cormat = cormat, tcholC = tcholC,
                             w = w))
}


#' Initialisation of a random rotation Object
#'
#' Initialization of a linear model for subsequent generation of randomly
#' rotated data (\code{\link[randRotation:randrot]{randrot}}) associated with
#' the null hypothesis \eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0}.
#' Basics of rotation tests are found in \insertCite{Hettegger2021}{randRotation} and
#' \insertCite{Langsrud2005}{randRotation}.
#'
#' @param Y a data matrix with \code{features x samples} dimensions or a list
#'   with elements \code{E}, \code{design} and \code{weights} (see
#'   \code{Details}). Missing values (\code{\link[base:NA]{NA}}) are allowed but
#'   e.g. lead to NAs for all samples of the respective features in the rotated
#'   dataset and should thus be avoided. We highly recommend avoiding missing
#'   values by e.g. replacing them by imputation or removing features containing
#'   NAs.
#' @param X the design matrix of the experiment with \code{samples x
#'   coefficients} dimensions. For \code{initBatchRandrot}, specify the design
#'   matrix without the batch variable. A warning is generated if
#'   \code{X[,coef.d]} does not have full rank, see Details.
#' @param coef.h single integer or vector of integers specifying the "hypothesis
#'   coefficients" (\code{H0} coefficients). \code{coef.h} should correspond to
#'   the last columns in \code{X} (see \code{Details}). If available,
#'   \code{attr(X, "coef.h")} is used, see
#'   \code{\link[randRotation:contrastModel]{contrastModel}}. By default, all
#'   coefficients are set as \code{H0} coefficients. If \code{coef.h} is set
#'   \code{-1}, no coefficient is set as \code{H0} coefficient.
#' @param weights numerical matrix of finite positive weights > 0 (as in
#'   weighted least squares regression. Dimensions must be equal to dimensions
#'   of \code{Y}.
#' @param cormat the sample correlation matrix with \code{samples x samples}
#'   dimensions. Must be a real symmetric positive-definite square matrix. See
#'   \code{Details} for usage in \code{initBatchRandrot}.
#'
#' @rdname initRandrot
#' @return An initialised
#'   \code{\link[randRotation:initRandrot-class]{initRandrot}},
#'   \code{\link[randRotation:initRandrot-class]{initRandrotW}} or
#'   \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot}}
#'   object.
#' @author Peter Hettegger
#' @references \insertAllCited{}
#'
#' @details
#'
#' This function performs basic initial checks and preparatory calculations for
#' random rotation data generation.
#' Nomenclature of variables is mainly as in
#' \insertCite{Langsrud2005}{randRotation} and \insertCite{Hettegger2021}{randRotation}. See also package vignette for
#' application examples.
#'
#' \code{Y} can also be a list with elements \code{E}, \code{design} and
#' \code{weights}. \code{Y$E} is thereby used as \code{Y}, \code{Y$design} is
#' used as \code{X} and \code{Y$weights} is used as \code{weights}. By this, the
#' functions are compatible with results from e.g. \code{voom} (\code{limma}
#' package), see \code{Examples}.
#'
#' \code{coef.h} specifies the model coefficients associated with the null
#' hypothesis ("hypothesis coefficients"). All other model coefficients are
#' considered as "determined coefficients" \code{coef.d}
#' \insertCite{Langsrud2005}{randRotation}. The design matrix is rearranged so
#' that \code{coef.h} correspond to the last columns of the design matrix and
#' \code{coef.d} correspond to the first columns of the design matrix. This
#' is necessary for adequate transformation of the combined null-hypothesis
#' \eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0} by QR decomposition.
#' If \code{X[,coef.d]} does not have full rank, a warning is generated and
#' \code{coef.d} is set to \code{coef.d <- seq_len(qr(X[,coef.d])$rank)}.
#'
#'
#' Weights must be finite positive \code{numerics} greater zero. This is
#' necessary for model (QR) decomposition and for back transformation of the
#' rotated data into the original variance structure, see also
#' \code{\link[randRotation:randrot]{randrot}}. Weights as estimated e.g. by
#' voom \insertCite{Law2014}{randRotation} are suitable and can be used without
#' further processing. Note that due to the whitening transformation (i.e. by
#' using the arguments \code{weights} and/or \code{cormat}) the rank of the
#' transformed (whitened) design matrix \code{X} could change (become smaller),
#' which could become dangerous for the fitting procedures. If you get errors
#' using \code{weights} and/or \code{cormat}, try the routine without using
#' \code{weights} and/or \code{cormat} to exclude this source of errors.
#'
#'
#' The following section provides a brief summary how rotations are calculated.
#' A more general introduction is given in
#' \insertCite{Langsrud2005}{randRotation}. For reasons of readability, we omit
#' writing \code{\%*\%} for matrix multiplication and write \code{*} for
#' transposed matrix. The rotation is done by multiplying the \code{features x
#' samples} data matrix \code{Y} with the transpose of the restricted random
#' rotation matrix \code{Rt}
#'
#' \code{Rt = Xd Xd* + [Xh  Xe] R [Xh  Xe]*}
#'
#' with \code{R} being a (reduced) random rotation matrix and \code{Xd},
#' \code{Xh} and \code{Xe} being columns of the full QR decomposition of the
#' design matrix \code{X}. \code{[Xd Xh Xe] = qr.Q(qr(X), complete = TRUE)},
#' where \code{Xd} correspond to columns \code{coef.d}, \code{Xh} to columns
#' \code{coef.h} and \code{Xe} to the remaining columns.
#'
#' If \code{weights} and/or \code{cormat} are specified, each feature
#' \code{Y[i,]} and the design matrix \code{X} are whitening transformed before
#' rotation. The whitening matrix \code{T} is defined as \code{T = solve(C) w},
#' where \code{solve(C)} is the inverse Cholesky decompostion of the correlation
#' matrix (\code{cormat = CC*}) and \code{w} is a diagonal matrix of the square
#' roots of the sample weights for the according feature (\code{w =
#' diag(sqrt(weights[i,]}))).
#'
#' The rotated data for one feature \code{y.r[i,]} is thus calculated as
#'
#' \code{y.r[i,] = ( solve(T) Rt T (y[i,])* )*} and \code{[Xd Xh Xe] =
#' qr.Q(qr(TX), complete = TRUE)}
#'
#' For \code{weights = NULL} and \code{cormat = NULL}, \code{T} is the identity
#' matrix.
#'
#' Note that a separate QR decomposition is calculated for each feature if
#' \code{weights} are specified. The restricted random orthogonal matrix
#' \code{Rt} is calculated with the same reduced random orthogonal matrix \code{R}
#' for all features.
#'
#' @export
#' @seealso \code{\link[randRotation:randrot]{randrot}},
#'   \code{\link[randRotation:rotateStat]{rotateStat}}
#'
#' @import methods
#' @importFrom stats approx ecdf p.adjust ppoints qqline qqplot quantile qunif
#'   rnorm spline
#' @importFrom utils head
#' @examples
#' # For further examples see '?rotateStat' and package vignette.
#'
#' # Example 1: Compatibility with limma::voom
#'
#' \dontrun{
#' v <- voom(counts, design)
#' ir <- initRandrot(v)}
#'
#' # Example 2:
#'
#' #set.seed(0)
#'
#' # Dataframe of phenotype data (sample information)
#' # We simulate 2 sample classes processed in 3 batches
#' pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
#'                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
#' features <- 100
#'
#' # Matrix with random gene expression data
#' edata <- matrix(rnorm(features * nrow(pdata)), features)
#' rownames(edata) <- paste("feature", 1:nrow(edata))
#'
#' mod1 <- model.matrix(~phenotype, pdata)
#'
#' # Initialisation of the random rotation class
#' init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
#' init1
setGeneric("initRandrot", function(Y = NULL, X = NULL, coef.h = NULL,
                                    weights = NULL, cormat = NULL)
  {standardGeneric("initRandrot")})



#' Initialised random rotation class
#'
#' List-based S4 class containing all information necessary to generate randomly
#' rotated data with the \code{\link[randRotation:randrot]{randrot}} method.
#' \code{initRandrot} and \code{initRandrotW} objects are created with the
#' \code{\link[randRotation:initRandrot]{initRandrot}} method.
#' @section Components: The following components are included as list elements:
#' \describe{
#'   \item{\code{X}}{Original (non-transformed) design matrix.}
#'   \item{\code{Xhe}, \code{Xhe.Y.w}, \code{Yd}}{Pre-multiplied matrix products needed for generation of rotated data (\code{\link[randRotation:randrot]{randrot}}).}
#'   \item{\code{coef.h}, \code{coef.d}}{Indices of \eqn{H_0}{H0} coefficients (\code{coef.h} or "hypothesis coefficients") and indices of all other coefficients (\code{coef.d} or "determined coefficients").}
#'   \item{\code{cormat}}{Correlation matrix, see \code{\link[randRotation:initRandrot]{initRandrot}}.}
#'   \item{\code{tcholC}}{Cholesky decomposition of cormat: \code{cormat = crossprod(tcholC)}.}
#'   \item{\code{rank}}{Rank of the qr decomposition of (transformed/whitened) \code{X}}
#' }
#' @export
#' @rdname initRandrot-class
setClass("initRandrot", contains = "list")

#' Initialised random rotation class with weights
#'
#' \code{initRandrotW} is organised as its base class \code{initRandrot},
#' altough some components are changed or added.
#' @section Components:
#' The following components are changed or added in \code{initRandrotW-class}
#' as compared to \code{initRandrot-class}:
#' \describe{
#'   \item{\code{decomp.list}}{List containing \code{Xd}, \code{Xhe} and rank of the transformed/whitened design matrix for each feature, see also \code{\link[randRotation:X_decomp]{X_decomp}}.}
#'   \item{\code{w}}{Numeric matrix with dimensions \code{features x samples} containing component wise square root of the weight matrix, see \code{\link[randRotation:initRandrot]{initRandrot}}.}
#' }
#' @export
#' @rdname initRandrot-class
#' @author Peter Hettegger
setClass("initRandrotW", contains = c("initRandrot", "list"))



#' Initialised random rotation batch object
#'
#' This class contains \code{initRandrot} or \code{initRandrotW} class
#' objects for each batch. See also descriptions in
#' \code{\link[randRotation:initRandrot]{initRandrot}} and
#' \code{\link[randRotation:initRandrot-class]{initRandrot-class}}.
#' @section Components:
#' \describe{
#'   \item{\code{batch.obj}}{List of \code{initRandrot} or \code{initRandrotW} class objects for each batch.}
#'   \item{\code{split.by}}{List of sample indices for each batch.}
#' }
#' @export
#' @author Peter Hettegger
setClass("initBatchRandrot", contains = c("list"))


#' Rotated object containing rotated and non-rotated statistics
#'
#' This list based class contains calculated statistics for the original data
#' (\code{s0}) and rotated data (\code{stats}). See also
#' \code{\link[randRotation:rotateStat]{rotateStat}}.
#' @section Components:
#' \describe{
#'   \item{\code{s0}}{Calculated statistics for original (non-rotated) data as returned by the \code{statistic} function (\code{\link[randRotation:rotateStat]{rotateStat}}).}
#'   \item{\code{stats}}{List of length \code{ncol.s} containing statistics on rotated data for each column returned by the \code{statistic} function.}
#'   \item{\code{ncol.s}}{Number of columns returned by the \code{statistic} function.}
#'   \item{\code{R}}{Number of resamples/rotations.}
#' }
#' @export
#' @author Peter Hettegger
setClass("rotateStat", contains = "list")




initBatchRandrot <- function(Y = NULL, X = NULL, coef.h = NULL, batch = NULL,
                               weights = NULL, cormat = NULL)
{
  if(is.null(batch) || (length(batch) != ncol(Y)))
    stop("Please specify batch variable with length(batch) being equal to ncol(Y)")

  tmp1 <- seq_along(batch)
  names(tmp1) <- colnames(Y)
  spl1 <- split(tmp1, batch)


  Y.l <- lapply(spl1, function(i){
    Y[,i,drop = FALSE]
  })

  X.l <- lapply(spl1, function(i){
    X[i,,drop = FALSE]
  })

  weights.l <- lapply(spl1, function(i){
    weights[,i,drop = FALSE]
  })


  initRandrot.l <- lapply(seq_len(length(spl1)), function(i){
    cat("Initialising batch \"", names(spl1)[i], "\"\n", sep = "")
    initRandrot(Y = Y.l[[i]], X = X.l[[i]], coef.h = coef.h,
                 weights = weights.l[[i]], cormat = cormat[[i]])
  })


  new("initBatchRandrot", list(batch.obj = initRandrot.l, split.by = spl1))

}



#' @param batch Batch covariate of the same length as \code{ncol(Y)}.
#' @export
#' @details When using \code{initBatchRandrot}, \code{initRandrot} is called
#'   for each batch separately. When using \code{initBatchRandrot} with
#'   \code{cormat}, \code{cormat} needs to be a list of correlation matrices
#'   with one matrix for each batch. Note that this implicitly assumes a block
#'   design of the sample correlation matrix, where sample correlation
#'   coefficients between batches are zero. For a more general sample
#'   correlation matrix, allowing non-zero sample correlation coefficients
#'   between batches, see package vignette. Batches are split according to
#'   \code{split(seq_along(batch), batch)}.
#'
#' @rdname initRandrot
#'
#' @examples # See '?rotateStat'
setGeneric("initBatchRandrot",
           function(Y = NULL, X = NULL, coef.h = NULL, batch = NULL,
                    weights = NULL, cormat = NULL) {standardGeneric("initBatchRandrot")})


#' @export
#' @rdname initRandrot
setMethod("initBatchRandrot", "list",
          function(Y = NULL, X = Y$design, coef.h = NULL, batch = NULL, weights = Y$weights, cormat = NULL){
            initBatchRandrot(Y = Y$E, X = X, coef.h = coef.h, batch = batch, weights = weights, cormat = cormat)
          })



#' @export
#' @rdname initRandrot
setMethod("initRandrot", "list",
          function(Y = NULL, X = Y$design, coef.h = NULL, weights = Y$weights, cormat = NULL){
            initRandrot(Y = Y$E, X = X, coef.h = coef.h, weights = weights, cormat = cormat)
          })





#' Create transformed model matrix for contrast rotation
#'
#' This function takes a model matrix \code{X} and a contrast matrix \code{C}
#' and creates a transformed model matrix corresponding to a transformed set
#' of coefficients.
#'
#' @param X \code{(numeric)} model matrix with dimensions
#' \code{samples x coefficients}.
#' @param C \code{(numeric)} contrast matrix with dimensions
#' \code{coefficients x contrasts}. The contrast matrix must have full column rank.
#' @param coef.h column numbers of contrasts (in \code{C}) which should be set
#' as \code{coef.h} in the transformed model, see
#' \code{\link[randRotation:initRandrot]{initRandrot}}. All columns are set as
#' \code{coef.h} by default.
#'
#' @details
#' The last n coefficients of the transformed model matrix correspond to the n
#' contrasts. By default, all contrasts are set as \code{coef.h}.
#' See package vignette for examples of data rotations with contrasts.
#'
#' @return A transformed model matrix with \code{coef.h} set as attribute.
#' @export
#' @author Peter Hettegger
#' @examples
#'
#' group <- c("A", "A", "B", "B")
#' X <- model.matrix(~0+group)
#' C <- cbind(contrast1 = c(1, -1))
#' X2 <- contrastModel(X, C)
contrastModel <- function(X, C, coef.h = seq_len(ncol(C))){

  if(!(is.matrix(X)) || (!is.matrix(C)))
    stop("X and C must be numeric matrices.")

  stopifnot(ncol(X) == nrow(C))

  c1 <- ncol(C)
  k1 <- nrow(C)

  qr1 <- qr(C)

  if(qr1$rank != c1) stop("C must have full column rank.")

  Q.s <- qr.Q(qr1, TRUE)
  Q.s <- Q.s[,c((c1+1):k1, seq_len(c1))]

  R <- qr.R(qr1)
  R.sti <- diag(k1)
  R.sti[(k1-c1+1):k1, (k1-c1+1):k1] <- forwardsolve(t(R), diag(ncol(R)))

  X.transformed <- X %*% Q.s %*% R.sti
  coef.h <- ((k1-c1+1):k1)[coef.h]
  attr(X.transformed, "coef.h") <- coef.h
  colnames(X.transformed)[coef.h] <- colnames(C)
  X.transformed
}




#' Show an Object
#'
#' Display the object by printing structured summary information.
#'
#' @param object An object of class
#'   \code{\link[randRotation:initRandrot-class]{initRandrot-class}},
#'   \code{\link[randRotation:initRandrot-class]{initRandrotW-class}} or
#'   \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.
#'
#'
#' @export
#' @rdname show
#' @return \code{show} returns an invisible \code{NULL}.
#' @details The show method always displays the original design matrix
#'   (\code{X}), not the transformed (whitened) versions.

setMethod("show", "initRandrot",
          function(object)
          {
            cat("Initialised random rotation object", if(!is.null(object$w))"(with weights)","\n\n")
            cat(dim(object$Yd)[1], "features   ", dim(object$Yd)[2], "samples\n\n")
            cat("Coefficients to test (coef.h):", colnames(object$X)[object$coef.h], "\n\n")

            cat("design matrix (X):\n")
            print(head(object$X, n = 6))
            if(nrow(object$X) > 6)cat(".\n.\n",nrow(object$X)-6, "more rows\n")

            if(!is.null(object$cormat)){
              cat("\ncorrelation matrix (cormat) - showing first 6x6 entries:\n")
              show.i <- seq_len(min(6, nrow(object$cormat)))
              show.j <- seq_len(min(6, ncol(object$cormat)))
              print(object$cormat[show.i, show.j, drop = FALSE])
              cat("\n")
            }

            if(!is.null(object$w)){
              cat("\nweights - showing first 6x6 entries:\n")
              show.i <- seq_len(min(6, nrow(object$w)))
              show.j <- seq_len(min(6, ncol(object$w)))
              print((object$w[show.i, show.j, drop = FALSE])^2)
              cat("\n")
            }

            cat("\n\n")

            invisible() # return NULL

          }
)


#' @rdname show
#' @export

setMethod("show", "initBatchRandrot",
          function(object)
          {
            cat("Initialised batch random rotation ojbect - In the following, the structure of each batch is listed separately:\n\n")

            invisible(lapply(seq_along(object$batch.obj), function(i){
              cat("##########################\n")
              cat("     BATCH ", i)
              cat("\n##########################\n\n")

              show(object$batch.obj[[i]])
            }))
            invisible() # return NULL
          }
)

#' @rdname show
#' @export

setMethod("show", "rotateStat",
          function(object)
          {
            cat("Rotate stat object\n\n")
            cat("R =", object$R)
            cat("\n\ndim(s0):", dim(object$s0))
            cat("\n\nStatistic:\n")
            cat(show(object$statistic))
            cat("\nCall:\n")
            cat(show(object$call))
            invisible() # return NULL
          }
)


#' Extract model weights
#'
#' \code{weights} is a generic function which extracts fitting weights from objects returned by modeling functions.
#' NOTE: This man page is for the weights S4 generic function defined in the \link[randRotation:randRotation-package]{randRotation} package.
#'
#' @inheritParams show,initRandrot-method
#' @param ... Kept for compatibility with the default method, see
#' \code{?stats::\link[stats:weights]{weights}}.
#' For objects defined in package \link[randRotation:randRotation-package]{randRotation},
#' this argument is currently not needed.
#'
#' @export
#' @rdname weights
#' @return Weights extracted from the object \code{object}. \code{NULL} if no
#' weights were specified.
#' See \code{?stats::\link[stats:weights]{weights}} for the value returned by the default method.
#'
#' @examples
#' weights
#' showMethods("weights")
#' selectMethod("weights", "ANY")  # the default method
#'
setMethod("weights", "initRandrot",
          function(object,...){
            object$w^2
          }
)

#' @rdname weights
#' @export
setMethod("weights", "initBatchRandrot",
          function(object,...){
            do.call(cbind, lapply(object$batch.obj, weights))
          }
)



#' Random rotation of initialised object
#'
#' Perform random data rotation of a previously initialised object (see
#' \code{\link[randRotation:initRandrot]{initRandrot}}) associated with the
#' null hypothesis \eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0}.
#'
#'
#' @param object An initialised object of class
#'   \code{\link[randRotation:initRandrot-class]{initRandrot-class}} or
#'   \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.
#'
#' @param ... further arguments passed to
#'   \code{\link[randRotation:randorth]{randorth}}
#'
#' @return \code{numeric} matrix of rotated data under the specified combined
#'   null hypothesis.
#' @export
#' @rdname randrot
#' @details
#'
#' This function generates a randomly rotated dataset from an initialised
#' randrot object (see \code{\link[randRotation:initRandrot]{initRandrot}}).
#' See also package vignette for application examples. Only the numerical matrix
#' of rotated data is returned, no design matrix, weights or other info is
#' return for efficiency purposes. Please consider that, if you e.g. use
#' \code{weights} or if you use
#' \code{\link[randRotation:rotateStat]{rotateStat}}, you may need to forward
#' the design matrix \code{X}, \code{weights} etc. to subsequent analyses. See
#' the example in \code{\link[randRotation:rotateStat]{rotateStat}}.
#'
#' Details on the calculation of a rotated dataset are given in
#' \code{\link[randRotation:initRandrot]{initRandrot}},
#' \insertCite{Langsrud2005}{randRotation} and \insertCite{Hettegger2021}{randRotation}.
#'
#' @author Peter Hettegger
#' @references \insertAllCited{}
#' @examples
#' # For further examples see '?rotateStat' and package vignette.
#'
#' #set.seed(0)
#'
#' # Dataframe of phenotype data (sample information)
#' # We simulate 2 sample classes processed in 3 batches
#' pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
#'                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
#' features <- 100
#'
#' # Matrix with random gene expression data
#' edata <- matrix(rnorm(features * nrow(pdata)), features)
#' rownames(edata) <- paste("feature", 1:nrow(edata))
#'
#' mod1 <- model.matrix(~phenotype, pdata)
#'
#' # Initialisation of the random rotation class
#' init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2,
#'                             batch = pdata$batch)
#' init1
#'
#' ### Fit model to original data
#'
#' fit.orig <- lm.fit(mod1, t(edata))
#' head(t(coef(fit.orig)))
#'
#' ### Fit model to rotated data
#'
#' edata.rot <- randrot(init1)
#' fit.rot <- lm.fit(mod1, t(edata.rot))
#' head(t(coef(fit.rot)))
#'
#'
#' # Note that the coefficients stay equal if we regress only on the
#' # non-hypothesis coefficients
#'
#' mod0 <- model.matrix(~1, pdata)
#' fit.orig0 <- lm.fit(mod0, t(edata))
#' fit.rot0  <- lm.fit(mod0, t(edata.rot))
#' head(t(coef(fit.orig0)))
#' head(t(coef(fit.rot0)))
#'
setGeneric("randrot", function(object, ...) standardGeneric("randrot"))






#' @export
#' @rdname randrot

setMethod("randrot", "initRandrot",
          function(object,...){
            ### No excessive initial checks for efficiency purposes.
            R <- randorth(nrow(object$Xhe.Y.w),...)

            if(is.null(object$cormat))
              (object$Yd + t(object$Xhe %*% R %*% object$Xhe.Y.w))
            else
              (object$Yd + t(object$Xhe %*% R %*% object$Xhe.Y.w)) %*% object$tcholC
          })


#' @rdname randrot
#' @export
setMethod("randrot", "initRandrotW",
          function(object,...){
            ### No excessive initial checks for efficiency purposes.
            R <- randorth(nrow(object$Xhe.Y.w),...)

            R.Xhe.Y.w <- R %*% object$Xhe.Y.w

            n <- length(object$decomp.list)
            Yhe <- t(vapply(seq_len(n), function(i){
              object$decomp.list[[i]]$Xhe %*% R.Xhe.Y.w[,i,drop = FALSE]
            }, numeric(ncol(object$Yd))))

            # de-whitening of Y.w
            if(is.null(object$cormat))
              (1/object$w) *  (object$Yd + Yhe)
            else
              (1/object$w) * ((object$Yd + Yhe) %*% object$tcholC)
          })




#' @rdname randrot
#' @export
setMethod("randrot", "initBatchRandrot",
          function(object,...){
            ord1 <- order(unlist(object$split.by))

            ### Perform randrot for each batch an sort back to initial order as
            ### in the design matrix.
            do.call(cbind,
                    lapply(object$batch.obj, randrot, ...)
                    )[,ord1,drop=FALSE]
          })




#' Generate data rotations and calculate statistics on it
#'
#' This function generates rotations of data and calculates the provided \code{statistic} on each rotation and the non-rotated (original) data.
#' This is the central function of the package.
#'
#' @param initialised.obj An initialised random rotation object as returned by \code{\link[randRotation:initRandrot]{initRandrot}} and \code{\link[randRotation:initRandrot]{initBatchRandrot}}.
#' @param R The number of resamples/rotations. Single \code{numeric} larger than 1.
#' @param statistic A function which takes a data matrix (same dimensions as \code{Y} - see also \code{\link[randRotation:initRandrot]{initRandrot}}) as first argument and returns a statistic of interest. Any further arguments are passed to it with the \code{...} argument.
#' We highly recommend using pivotal quantities as \code{statistic} if possible (see also \code{Details} in \code{\link[randRotation:pFdr]{pFdr}}).
#' Note that \code{\link[randRotation:pFdr]{pFdr}} considers larger values of statistics as more significant, so one-tailed tests may require reversal of the sign and two-tailed tests may require taking absolute values, see \code{Examples}.
#' The results of \code{statistic} for each resample are finally combined with \code{as.matrix} and \code{cbind}, so ensure that \code{statistic} returns either a vector or a matrix.
#' Results with multiple columns are possible and handled adequately in subsequent functions (e.g. \code{\link[randRotation:pFdr]{pFdr}}). Note that \code{statistic} must not necessarily be of the same length as \code{nrow(Y)}, but can also be e.g. a summary statistic of genes (like in gene set testing).
#' @param ... Further named arguments for \code{statistic} which are passed unchanged each time it is called.
#' Avoid partial matching to arguments of \code{rotateStat}. See also the \code{Examples}.
#' @param parallel \code{logical} if parallel computation should be performed, see details for use of parallel computing.
#' @param BPPARAM An optional \code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}} instance, see documentation of \code{BiocParallel} package of Bioconductor.
#'
#' @return An object of class \code{\link[randRotation:rotateStat-class]{rotateStat}}.
#' @rdname rotateStat
#' @export
#' @details
#'
#' The function takes an initialised randrot object
#' (\code{\link[randRotation:initRandrot]{initRandrot}}) and a function that
#' calculates a statistic on the data. The statistic function thereby takes the
#' a matrix \code{Y} as first argument. Any further arguments are passed to it
#' by \code{...}.
#'
#' Together with \code{\link[randRotation:pFdr]{pFdr}}, this function implements
#' the \code{workflow} described in \insertCite{Hettegger2021}{randRotation}.
#'
#' Be aware that only data is rotated (see also
#' \code{\link[randRotation:randrot]{randrot}}), so any additional information
#' including \code{weights}, \code{X} etc. need to be provided to
#' \code{statistic}. See also package vignette and \code{Examples}.
#'
#' Parallel processing is implemented with the BiocParallel package of Bioconductor.
#' The default argument \code{\link[BiocParallel:register]{BiocParallel::bpparam()}} for \code{BPPARAM}
#' returns the registered default backend.
#' See package documentation for further information and usage options.
#' If \code{parallel = TRUE} the function calls in \code{statistic} need to be called explicitly
#' with package name and "::". So e.g. calling \code{lmFit} from the
#' \code{limma} package is done with \code{limma::lmFit(...)}, see also the
#' examples in the package vignette.
#'
#' @author Peter Hettegger
#' @references \insertAllCited{}
#' @examples
#' #set.seed(0)
#'
#' # Dataframe of phenotype data (sample information)
#' # We simulate 2 sample classes processed in 3 batches
#' pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
#'                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
#' features <- 100
#'
#' # Matrix with random gene expression data
#' edata <- matrix(rnorm(features * nrow(pdata)), features)
#' rownames(edata) <- paste("feature", 1:nrow(edata))
#'
#' mod1 <- model.matrix(~phenotype, pdata)
#'
#' # Initialisation of the random rotation class
#' init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
#' init1
#'
#' # Definition of the batch effect correction procedure with subsequent calculation
#' # of two-sided test statistics
#' statistic <- function(., batch, mod, coef){
#'
#'   # The "capture.output" and "suppressMessages" simply suppress any output
#'   capture.output(suppressMessages(
#'     Y.tmp <- sva::ComBat(., batch = batch, mod)
#'   ))
#'
#'   fit1 <- lm.fit(mod, t(Y.tmp))
#'   abs(coef(fit1)[coef,])
#' }
#'
#' # We calculate test statistics for the second coefficient
#'
#' res1 <- rotateStat(initialised.obj = init1,
#'                     R = 10,
#'                     statistic = statistic,
#'                     batch = pdata$batch, mod = mod1, coef = 2)
#'
#' hist(pFdr(res1))

rotateStat <- function(initialised.obj, R = 10, statistic, ...,
                        parallel = FALSE,
                        BPPARAM = BiocParallel::bpparam()){

  if(R<1) stop("R must be at least 1")

  FUN <- {
    # This definition is necessary for parallel processing
    statistic
    initialised.obj
    function(j, ...) statistic(randrot(initialised.obj, I.matrix = (j == 1)), ...)
    }

  i <- seq_len(R+1)

  if(parallel){
    stats <- BiocParallel::bplapply(X = i, FUN = FUN, ..., BPPARAM = BPPARAM)
  } else {
    stats <- lapply(X = i, FUN = FUN, ...)
  }

  ## The "statistic" function can return results with multiple columns. Thus the
  ## results are organized accordingly in lists (one list element for each
  ## column).

  stats <- lapply(stats, as.matrix)

  s0 <- stats[[1]]
  ncol.s <- ncol(s0)

  stats <- stats[-1]

  stats <- lapply(
    seq_len(ncol.s),
    function(i)
      do.call(cbind,lapply(stats, function(tmp.stat) tmp.stat[,i,drop = FALSE]))
    )

  names(stats) <- colnames(s0)

  new("rotateStat", list(s0 = s0, stats = stats, ncol.s = ncol.s, R = R,
                          call = sys.call(), statistic = statistic,
                          w = (length(weights(initialised.obj)) > 0)))
}


#' Dimensions of an Object
#'
#' Retrieve the dimensions of an object.
#'
#' @param x An object of class
#'   \code{\link[randRotation:initRandrot-class]{initRandrot-class}} or
#'   \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.
#'
#'
#' @export
#' @rdname dim
#' @return Vector of length two with number of \code{features} and number of
#'   \code{samples}. See also
#'   \code{\link[randRotation:initRandrot]{initRandrot}}.
setMethod("dim", "initRandrot", function(x)dim(x$Yd))

#' @export
#' @rdname dim
setMethod("dim", "initBatchRandrot",
          function(x)c(nrow(x$batch.obj[[1]]), sum(lengths(x$split.by))))

#' Dimnames of an Object
#'
#' Retrieve the dimnames of an object.
#'
#' @param x An object of class
#'   \code{\link[randRotation:initRandrot-class]{initRandrot-class}} or
#'   \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.
#'
#'
#' @return A \code{list} with names of \code{features} and \code{samples}, see
#'   \code{\link[randRotation:initRandrot]{initRandrot}}.
#' @export
#' @rdname dimnames
setMethod("dimnames", "initRandrot", function(x)dimnames(x$Yd))


#' @export
#' @rdname dimnames
setMethod("dimnames", "initBatchRandrot",
          function(x)list(rownames(x$batch.obj[[1]]$Yd),
                          unlist(lapply(x$split.by, names), use.names = FALSE)))

#' Random orthogonal matrix
#'
#' Generation of a random orthogonal \code{n x n} matrix.
#'
#' @param n \code{numeric} of length 1 defining the dimensions of the \code{n x n} square matrix.
#' @param type Either \code{"orthonormal"} or \code{"unitary"} defining whether a real orthonormal matrix or a complex unitary matrix should be returned.
#' @param I.matrix If \code{TRUE}, the identity matrix is returned.
#'
#' @return A random orthogonal matrix of dimension \code{n x n}.
#' @export
#' @details
#' A random orthogonal matrix \code{R} is generated in order that \code{t(R)} (for \code{"orthonormal"}) or \code{Conj(t(R))} (for \code{"unitary"}) equals the inverse matrix of \code{R}.
#'
#' This function was adapted from the pracma package (\code{\link[pracma:randortho]{pracma::randortho}}).
#'
#' The random orthogonal matrices are distributed with Haar measure over
#' \code{O(n)}, where \code{O(n)} is the set of orthogonal matrices of order \code{n}.
#' The random orthogonal matrices are basically distributed "uniformly" in the
#' space of random orthogonal matrices of dimension \code{n x n}.
#' See also the \code{Examples} and \insertCite{Stewart1980a,Mezzadri2007}{randRotation}.
#'
#'
#' @references \insertAllCited{}
#' @author Peter Hettegger
#' @importFrom graphics smoothScatter
#' @examples
#'
#' # The following example shows the orthogonality of the random orthogonal matrix:
#' R1 <- randorth(4)
#' zapsmall(t(R1) %*% R1)
#'
#' R1 <- randorth(4, "unitary")
#' zapsmall(Conj(t(R1)) %*% R1)
#'
#' # The following example shows the distribution of 2-dimensional random orthogonal vectors
#' # on the unit circle.
#' tmp1 <- vapply(1:400, function(i)randorth(2)[,1], numeric(2))
#' plot(t(tmp1), xlab = "x", ylab = "y")
#'
randorth <- function (n, type = c("orthonormal", "unitary"), I.matrix = FALSE)
{
  if(I.matrix) return(diag(n))
  ### this function was adapted from the pracma package (randortho function)

  stopifnot(is.numeric(n), length(n) == 1, floor(n) == ceiling(n),
            n >= 0)

  if(n == 0) return(matrix(1,0,0))

  type <- match.arg(type)
  if (type == "orthonormal") {
    z <- matrix(rnorm(n^2), n)
  }
  else {
    z <- (matrix(rnorm(n^2), n) + (0+1i) * matrix(rnorm(n^2), n))
  }
  Z <- qr(z)
  q <- qr.Q(Z)
  r <- qr.R(Z)
  d <- diag(r)
  ph <- d/abs(d)
  q %*% diag(ph, length(ph))
}




#' Generate random permutation matrix for n samples
#'
#' Generate a random permutation matrix for \code{n} samples.
#'
#' @param n Number of samples
#'
#' @return A random permutation matrix of dimension \code{n x n}
#' @export
#' @details This methods generates an orthogonal matrix with only
#'   one entry in each row and column being \code{1}, all other entries being
#'   \code{0}.
#' @examples
#' tmp1 <- randpermut(5)
#' t(tmp1) %*% tmp1
#' @author Peter Hettegger
randpermut <- function(n){
  m1 <- matrix(0,n,n)
  m1[cbind(seq_len(n),sample(n))] <- 1
  m1
}



#' Internal functions for p-value and FDR estimation
#'
#' @param s0 \code{numeric} vector of original (non-rotated) statistics.
#' @param stats \code{numeric} matrix of rotated statistics.
#' @param beta \code{numeric} between 0 and 1. See \insertCite{Yekutieli1999}{randRotation}.
#' @param na.rm \code{logical}. Should missing values be removed ?
#' @param ref.vector Reference vector defining at which grid points of \code{s0}
#'   and (\code{stats}) the FDRs are approximated. All other points are
#'   approximated by spline interpolation. NAs are removed from ref.vector
#'
#' @return \code{numeric} vector of (adjusted) p-value or FDR estimations for \code{s0}.
#' @rdname fdr_p
#' @keywords internal
#' @references \insertAllCited{}

.fdr.qu <- function(s0, stats, beta = 0.05, na.rm = FALSE,
                    ref.vector = sort(s0, decreasing = TRUE, na.last = TRUE))
{
  ref.vector <- ref.vector[!is.na(ref.vector)]
  stats.max <- max(stats, na.rm = na.rm)
  ref.vector <- ref.vector[ref.vector <= stats.max]
  ref.vector.size <- length(ref.vector)

  r.vector <- vapply(ref.vector,
                     function(i) sum(s0 >= i, na.rm = na.rm), numeric(1))

  qu.value <- vector("numeric", ref.vector.size)
  est.95qu.exc <- vector("numeric", ref.vector.size)
  su.hat <- vector("numeric", ref.vector.size)

  for (i in seq_len(ref.vector.size)) {
    v <- colSums(stats >= ref.vector[i], na.rm = na.rm)
    est.95qu.exc[i] <- quantile(v, prob = (1 - beta),
                                names = FALSE, na.rm = na.rm)
    su.hat[i] <- r.vector[i] - est.95qu.exc[i]
    su.hat[i] <- max(su.hat[i], 0, na.rm = na.rm) # negative su.hat makes no sense
    resamp.q <- ifelse((v + su.hat[i]) != 0, v/(v + su.hat[i]),0)
    qu.value[i] <- mean(resamp.q, na.rm = na.rm)
  }

  qu.value <- cummax(qu.value)

  # The pmin is necessary to prevent values > 1 due to approximation
  pmin(approx(spline(ref.vector, qu.value), xout = abs(s0), rule = 2)$y, 1)
}

#' @rdname fdr_p
#' @keywords internal
.fdr.q <- function(s0, stats, beta = 0.05, na.rm = FALSE,
                   ref.vector = sort(s0, decreasing = TRUE, na.last = TRUE))
{
  ref.vector <- ref.vector[!is.na(ref.vector)]
  stats.max <- max(stats, na.rm = na.rm)
  ref.vector <- ref.vector[ref.vector <= stats.max]
  ref.vector.size <- length(ref.vector)

  r.vector <- vapply(ref.vector,
                     function(i) sum(s0 >= i, na.rm = na.rm), numeric(1))

  q.value <- vector("numeric", ref.vector.size)
  est.95qu.exc <- vector("numeric", ref.vector.size)
  s.hat <- vector("numeric", ref.vector.size)

  for (i in seq_len(ref.vector.size)) {
    v <- colSums(stats >= ref.vector[i], na.rm = na.rm)
    est.95qu.exc[i] <- quantile(v, prob = (1 - beta),
                                names = FALSE, na.rm = na.rm)
    s.hat[i] <- r.vector[i] - mean(v, na.rm = na.rm)
    s.hat[i] <- ifelse(s.hat[i] < est.95qu.exc[i], 0, s.hat[i])
    resamp.q <- ifelse((v + s.hat[i]) != 0, v/(v + s.hat[i]),
                       0)
    q.value[i] <- mean(resamp.q, na.rm = na.rm)
  }
  q.value <- rev(cummin(rev(q.value)))

  # The pmin is necessary to prevent values > 1 due to approximation
  pmin(approx(spline(ref.vector, q.value), xout = abs(s0), rule = 2)$y, 1)
}

#' @param method A p-value or FDR adjustment method, see
#'   \code{\link[randRotation:pFdr]{pFdr}}.
#' @param pooled \code{logical}. \code{TRUE} if marginal distributions are
#'   exchangeable for all features so that rotated stats can be pooled, see
#'   \code{\link[randRotation:pFdr]{pFdr}}.
#' @rdname fdr_p
#' @keywords internal
.pFdr <- function(s0, stats, method, pooled, na.rm, beta){

  if(method %in% c("fdr.q", "fdr.qu") && pooled == FALSE)
    stop("Methods \"fdr.q\" and \"fdr.qu\" can only be used with pooled = TRUE")

  if(pooled == "FALSE"){
    ### The +1 are according to (Phipson and Smyth 2010).
    res <- (rowSums(stats >= s0, na.rm = na.rm)+1)/(rowSums(!is.na(stats))+1)
    res <- p.adjust(p = res, method = method)
  } else {

    if(method == "fdr.q"){
      res <- .fdr.q(s0, stats, beta = beta, na.rm = na.rm)
    } else if(method == "fdr.qu"){
      res <- .fdr.qu(s0, stats, beta = beta, na.rm = na.rm)
    } else {
      if(na.rm == FALSE && any(is.na(stats))){
        #### Calculating p-values with "stats" containing NAs and "na.rm =
        #### FALSE" results in only NAs
        warning("NAs found in rotated stats, but na.rm = FALSE.")
        res <- s0
        res[] <- NA
      } else {
        ### The "-" in ecdf and it's argument is necessary in order that the
        ### function behaves correctly for discrete statistics (i.e. in order
        ### that it is equivalent to ">=" instead of ">")
        ### The solution using ecdf is faster than iterating over all s0.
        ### The m and the +1 are according to (Phipson and Smyth 2010).
        m <- sum(!is.na(stats))
        ps <- (((ecdf(x = -stats)(-s0)) * m) + 1) / (m+1)
        res <- p.adjust(p = ps, method = method)
      }
    }
  }

  if(all(is.na(res))) warning("p-values / FDRs resulted only in NAs")

  res
}



#' Calculate resampling based p-values and FDRs
#'
#' This function calculates either (1) resampling based p-values with subsequent
#' p-value adjustment using \code{\link[stats:p.adjust]{stats::p.adjust}} or (2)
#' resampling based false-discovery-rates (FDRs) for rotated statistics from a
#' \code{\link[randRotation:rotateStat]{rotateStat}} object.
#'
#'
#' @param obj A \code{rotateStat} object as returned by \code{\link[randRotation:rotateStat]{rotateStat}}.
#' @param method Can be either \code{"none"} (default), \code{"fdr.q"}, \code{"fdr.qu"} or any term that can be passed as \code{method} argument to \code{\link[stats:p.adjust]{stats::p.adjust}}, see \code{Details}. If \code{method = "none"}, resampling based
#' p-values without further adjustment are calculated.
#' @param pooled \code{logical}. \code{TRUE} (default) if marginal distributions are exchangeable for all features so that rotated stats can be pooled, see \code{Details}.
#' @param na.rm \code{logical}. \code{NA} values are ignored if set \code{TRUE}. \code{NA} values should be avoided and could e.g. be removed by imputation in original data or by removing features that contain \code{NA} values. Few \code{NA} values do not have a large effect, but many \code{NA} values can lead to wrong estimations of p-values and FDRs. We highly recommend avoiding \code{NA} values.
#' @param beta \code{numeric} between \code{0} and \code{1}. Corresponds to beta in \insertCite{Yekutieli1999}{randRotation}.
#'
#' @return A \code{numeric} matrix of corrected p-values or FDRs with dimension \code{dim(obj$s0)}.
#' @export
#' @seealso \code{\link[randRotation:rotateStat]{rotateStat}}
#' @details Larger values of obj$s0 are considered more significant when
#'   compared to the empirical distribution. E.g. for calculation of resampling
#'   based p-values (with \code{pooled = FALSE}) we in principle use
#'   \code{p.val <- (rowSums(obj$stats >= obj$s0)+1)/(ncol(obj$stats)+1)} according to
#'   \insertCite{Phipson2010}{randRotation}.
#'
#'   \code{method = "fdr.q"} and \code{method = "fdr.qu"} are resampling based
#'   fdr estimates and can only be used with \code{pooled = TRUE}. \code{method
#'   = "fdr.q"} is the FDR local estimator and \code{method = "fdr.qu"} is the
#'   FDR upper limit, see \insertCite{Reiner2003,Yekutieli1999}{randRotation}.
#'   For all other \code{method} arguments resampling based p-values are
#'   calculated and passed to \code{\link[stats:p.adjust]{stats::p.adjust}} for
#'   p-value adjustment. So these methods provide resampling based p-values with
#'   (non-resampling based) p-value adjustment.
#'   \code{method = "fdr.q"} and \code{method = "fdr.qu"} were
#'   adapted from package \code{fdrame}
#'   \insertCite{Fdrame2019,Reiner2003}{randRotation}.
#'
#'   When \code{pooled = TRUE},
#'   marginal distributions of the test statistics are considered exchangeable
#'   for all features. The resampling based p-values of each feature are then
#'   calculated from all rotated statistics (all features, all rotations). For
#'   these cases, if the number of features is reasonably large, usually only
#'   few resamples (argument \code{R} in
#'   \code{\link[randRotation:rotateStat]{rotateStat}}) are required.
#'   We want to emphasize that in order for the marginal distributions to be
#'   exchangeable, the statistics must be a pivotal quantity (i.e. it must be
#'   scale independent).
#'   Pivotal quantities are e.g. t values. Using e.g. linear models
#'   with \code{coef} as statistics is questionable if the different features
#'   are measured on different scales. The resampled coefficients then
#'   have different variances and \code{pooled = TRUE} is not applicable.
#'   We thus highly recommend using pivotal quantities as \code{statistics} in
#'   \code{\link[randRotation:rotateStat]{rotateStat}}
#'   if possible.
#'
#'   When \code{pooled = FALSE} the resampling based p-values are calculcated
#'   for each feature separately. This is required if one expects the resampling
#'   based statistics to be distributed differently for individual features. For
#'   most common applications this should not be the case and the marginal
#'   distribution are exchangeable for all features, hence \code{pooled = TRUE}
#'   by default.
#'
#'   If \code{method = "fdr.q"} or \code{method = "fdr.qu"} and
#'   \code{weights} were specified when initialising the random rotation
#'   object (see parameter \code{initialised.obj} in
#'   \code{\link[randRotation:rotateStat]{rotateStat}}), a warning is displayed.
#'   The correlation structure (dependence structure) of linear model
#'   coefficients between different features is not generally preserved if
#'   different weights are used for different features.
#'   Methods \code{fdr.q} and \code{fdr.qu} rely on preserved correlation
#'   structure of dependent statistics and thus should not be used if statistics
#'   based on model coefficients (e.g. t statistics of model coefficients) are
#'   used in combination with different weights.
#'
#'   P-values and FDRs are calculated for each column of \code{obj$s0}
#'   separately.
#' @examples # See also '?rotateStat':
#'
#' #set.seed(0)
#'
#' # Dataframe of phenotype data (sample information)
#' # We simulate 2 sample classes processed in 3 batches
#' pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
#'                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
#' features <- 100
#'
#' # Matrix with random gene expression data
#' edata <- matrix(rnorm(features * nrow(pdata)), features)
#' rownames(edata) <- paste("feature", 1:nrow(edata))
#'
#' mod1 <- model.matrix(~phenotype, pdata)
#'
#' # Initialisation of the random rotation class
#' init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
#' init1
#'
#' # Definition of the batch effect correction procedure with subsequent calculation
#' # of two-sided test statistics
#' statistic <- function(., batch, mod, coef){
#'
#'   # The "capture.output" and "suppressMessages" simply suppress any output
#'   capture.output(suppressMessages(
#'     Y.tmp <- sva::ComBat(., batch = batch, mod)
#'   ))
#'
#'   fit1 <- lm.fit(mod, t(Y.tmp))
#'   abs(coef(fit1)[coef,])
#' }
#'
#' # We calculate test statistics for the second coefficient
#'
#' res1 <- rotateStat(initialised.obj = init1,
#'                     R = 10,
#'                     statistic = statistic,
#'                     batch = pdata$batch, mod = mod1, coef = 2)
#'
#' hist(pFdr(res1))
#' @references \insertAllCited{}
#' @author Peter Hettegger
pFdr <- function(obj, method = "none", pooled = TRUE, na.rm = FALSE, beta = 0.05){
  if(!is(obj, "rotateStat")) stop("class(obj) must be \"rotateStat\"")
  if(beta < 0 || beta > 1) stop("beta must be between 0 and 1")
  if(any(is.na(obj$s0)) || any(is.na(unlist(obj$stats))))
    warning("Missing values found in obj$s0 or obj$stats. Missing values are tolerated as much as possible, but should be avoided. See \"pFdr\" help page.")

  method <- match.arg(method, c("fdr.q", "fdr.qu", stats::p.adjust.methods))
  if(isTRUE(obj$w) && (method %in% c("fdr.q", "fdr.qu")))
    warning("Methods fdr.q and fdr.qu should not be used with weights (see ?pFdr).")

  res <- vapply(seq_len(obj$ncol.s),
                 function(i).pFdr(obj$s0[,i,drop = TRUE], obj$stats[[i]], method, pooled, na.rm, beta),
                 obj$s0[,1])

  # For the case that there is only one feature.
  # Otherwise the "colnames(res) <- colnames(obj$s0)" fails
  if(is.null(dim(res)) && (length(res) > 0)){
    if(obj$ncol.s > 1) res <- rbind(res)
    else
      res <- cbind(res)
  }


  colnames(res) <- colnames(obj$s0)
  res
}


#' Quantile-Quantile plot of data sample against uniform theoretical quantiles
#'
#' \code{qqunif} produces a QQ plot of the values in \code{ps} against the
#' theoretical quantiles of the uniform distribution.
#'
#' This function can e.g. be used for comparing p-values against the uniform
#' distribution. The log scale of the x and y axes allow a closer look at low
#' p-values.
#'
#' This function is a modified version of the examples in the
#' \code{\link[stats:qqnorm]{qqnorm}} documentation page.
#'
#' @importFrom graphics abline
#' @param ps \code{numeric} vector of values (e.g. p-values). Values must be
#'   between 0 and 1. Values like \code{NA}, NaN, Inf etc. produce an error.
#' @param log \code{character} indicating whether axis should be plotted in log
#'   scale. Either \code{""}, \code{"x"}, \code{"y"} or \code{"xy"}.
#' @param pch Point symbol, see \code{\link[graphics:par]{par}}.
#' @param xlab Label for the x axis.
#' @param ylab Label for the y axis.
#' @param plot.it \code{logical} whether the result should be plotted.
#' @param ... Graphical parameters forwarded to \code{\link[stats:qqnorm]{qqplot}}
#'
#' @return A list of \code{x} and {y} coordinates, as in \code{\link[stats:qqnorm]{qqplot}}.
#' @export
#'
#' @examples
#' qqunif(runif(100))
qqunif <- function(ps, log = "xy", pch = 20, xlab = "theoretical quantiles",
ylab = "sample quantiles", plot.it = TRUE, ...){

  if(any(!is.finite(ps) | ps > 1 | ps < 0))
    stop("Values of ps must be between 0 and 1.")

  ## Q-Q plot for Unif data against true theoretical distribution
  res <- qqplot(ppoints(ps), ps, main = expression("Q-Q plot for" ~~ {Unif(0,1)}),
         log = log, pch = pch, xlab = xlab, ylab = ylab, plot.it = plot.it, ...)
  if(plot.it)abline(0, 1, col = 2, lwd=2, lty=2)
  invisible(res)
}

test_that("Test execution of rotateStat (including parallel computation mode), pFdr with \"fdr.q\" and \"fdr.qu\"", {
  set.seed(0)
  # Dataframe of phenotype data (sample information)
  pdata = data.frame(batch = rep(1:3, c(10,10,10)),
                     phenotype = rep(c("Control", "Cancer"), c(5,5)))
  features = 100

  # Matrix with random gene expression data
  edata = matrix(rnorm(features * nrow(pdata)), features)
  rownames(edata) = paste("feature", 1:nrow(edata))
  colnames(edata) = paste("sample", 1:ncol(edata))

  mod1 = model.matrix(~phenotype, pdata)

  capture.output(init1 <- initBatchRandrot(edata, mod1, -1, pdata$batch))


  statistic <- function(Y, batch, mod, coef){
    capture.output(suppressMessages(Y.tmp <- sva::ComBat(Y, batch = batch, mod)))

    fit1 <- lm.fit(mod, t(Y.tmp))
    t(abs(coef(fit1)[coef,]))
  }

  res1 <- rotateStat(initialised.obj = init1,
                      R = 100,
                      statistic = statistic,
                      batch = pdata$batch, mod = mod1, coef = 1:2,
                      parallel = FALSE)

  expect_equal(sort(pFdr(res1))[1:10], c(0.0087991, 0.0094991, 0.0150985, 0.0196980, 0.0258974, 0.0267973, 0.0361964, 0.0393961, 0.0456954, 0.0472953), tolerance = 1e-5)
  expect_equal(sort(pFdr(res1, "fdr.q"))[1:10], c(0.87000, 0.94000, 0.99303, 0.99844, 0.99992, 0.99999, 1.00000, 1.00000, 1.00000, 1.00000), tolerance = 1e-5)
  expect_equal(sort(pFdr(res1, "fdr.qu"))[1:10], c(0.87000, 0.94000, 0.99303, 0.99844, 0.99992, 0.99999, 1.00000, 1.00000, 1.00000, 1.00000), tolerance = 1e-5)

  ### Test for exact dimensions and for parallel processing
  res1 <- rotateStat(initialised.obj = init1, R = 10, statistic = statistic,
                      batch = pdata$batch, mod = mod1, coef = 1:2,
                      parallel = TRUE)
  expect_equal(dim(pFdr(res1)), c(features,2))


  #### If "statistic" returns only 1 number, not one for each feature --> this still has to work properly !

  statistic <- function(Y, batch, mod, coef){
    capture.output(suppressMessages(Y.tmp <- sva::ComBat(Y, batch = batch, mod)))

    fit1 <- lm.fit(mod, t(Y.tmp))
    t(abs(coef(fit1)[coef,1]))
  }

  res1 <- rotateStat(initialised.obj = init1, R = 10, statistic = statistic,
                      batch = pdata$batch, mod = mod1, coef = 1:2,
                      parallel = FALSE)
  expect_equal(dim(pFdr(res1)), c(1,2))

  res1 <- rotateStat(initialised.obj = init1, R = 10, statistic = statistic,
                      batch = pdata$batch, mod = mod1, coef = 2,
                      parallel = FALSE)
  expect_equal(dim(pFdr(res1)), c(1,1))


  #### If "statistic" returns only 1 number, not one for each feature (this still has to work properly !)
  #### Additionally --> R = 1

  statistic <- function(Y, batch, mod, coef){
    capture.output(suppressMessages(Y.tmp <- sva::ComBat(Y, batch = batch, mod)))

    fit1 <- lm.fit(mod, t(Y.tmp))
    t(abs(coef(fit1)[coef,1]))
  }

  res1 <- rotateStat(initialised.obj = init1, R = 1, statistic = statistic,
                      batch = pdata$batch, mod = mod1, coef = 2,
                      parallel = FALSE)

  expect_equal(dim(pFdr(res1)), c(1,1))

  })

test_that("Model transformation by function contrastModel must result in equal contrast estimates.", {
  set.seed(0)
  # Dataframe of group data (sample information)
  pdata = data.frame(group = rep(c("1", "2", "3"), c(5,5,5)))
  features = 1

  # Matrix with random gene expression data
  edata <- matrix(rnorm(features * nrow(pdata)), nrow = features)
  rownames(edata) <- paste0("feature", 1:nrow(edata))

  mod1 <- model.matrix(~0+group, pdata)

  # weights
  w <- runif(nrow(pdata))


  # ordinary contrast estimates
  fit1 <- lm.wfit(x = mod1, y = t(edata), w = w)
  cont1 <- cbind(c1 = c(1,0,-1), c2 = c(0,-1,1))
  gamma1 <- drop(t(cont1) %*% coef(fit1))


  # transformed model
  mod.cont <- contrastModel(mod1, cont1)
  fit2 <- lm.wfit(x = mod.cont, y = t(edata), w = w)
  gamma2 <- coef(fit2)[attr(mod.cont, "coef.h")]

  expect_equal(gamma1, gamma2)

  })

test_that("Random orthogonal matrices are orthogonal ?", {
  sapply(1:3, function(i){
    r1 = randorth(i)
    expect_equal(r1 %*% t(r1), diag(ncol(r1)))
    r1 = randorth(i, "unitary")
    expect_equal(r1 %*% Conj(t(r1)), diag(ncol(r1))+0i)
  })
})

test_that("Random rotation gives same coefficients if all coefs are set as coef.d ?", {
  set.seed(0)
  # Dataframe of phenotype data (sample information)
  pdata = data.frame(phenotype = rep(c("Control", "Cancer"), c(5,5)))
  features = 10

  # Matrix with random gene expression data
  edata = matrix(rnorm(features * nrow(pdata)), nrow = features)
  rownames(edata) = paste0("feature", 1:nrow(edata))

  mod1 = model.matrix(~phenotype, pdata)

  rr1 = initRandrot(Y = edata, X = mod1, coef.h = -1)

  fit1 = lm.fit(x = mod1, y = t(edata))

  edata.rotated = randrot(rr1)
  fit.rotated = lm.fit(x = mod1, y = t(edata.rotated))

  expect_equal(coef(fit1), coef(fit.rotated))



  #### Test with weights specified

  weights = matrix(runif(length(edata))+0.2, nrow = nrow(edata))

  rr1 = suppressWarnings(initRandrot(Y = edata, X = mod1, coef.h = -1, weights = weights))

  coefs <- vapply(seq_len(features),
                  function(i) coef(lm.wfit(x = mod1, y = edata[i,], w = weights[i,])),
                  numeric(ncol(mod1)))

  edata.rot = randrot(rr1)

  coefs.rot <- vapply(seq_len(features),
                  function(i) coef(lm.wfit(x = mod1, y = edata.rot[i,], w = weights[i,])),
                  numeric(ncol(mod1)))

  expect_equal(coefs, coefs.rot)


  #### Test with correlation matrix and weights specified

  library(lme4)

  colnames(pdata) <- "individual"
  pdata$individual <- as.factor(rep(c("2", "1"), c(5,5)))
  df1 <- cbind(pdata, t(edata[1,,drop = FALSE]), w = weights[1,],
               phenotype = as.factor(c("Cancer.tissue", "Control.tissue")))

  ### add "individual" and "phenotype" effect to avoid numerical problems
  df1$feature1 = df1$feature1 + as.numeric(df1$individual)
  df1$feature1 = df1$feature1 + as.numeric(df1$phenotype)

  ### We take "phenotype" as hypothesis coefficient, hence it is omitted in the
  ### "coef.d only" model

  me0 <- lmer(feature1 ~ 1 + (1|individual), data = df1, weights = w)

  ### Note: The correct ("identical") parametrisation of the models is very
  ### important for data rotation !
  me1 <- lmer(feature1 ~ 1 + phenotype + (1|individual), data = df1, weights = w)
  mod1 <- as.matrix(cbind(getME(me1, "X"), getME(me1, "Z")))

  # Resort columns to avoid the following warning in "R CMD check":
  # warning("coef.h does not correspond to the last columns in the design matrix.")
  mod1 <- mod1[,c(1,3,4,2)]

  # Remove one column of the random effect to avoid the following warning in
  # "R CMD check":
  # warning("Partitioned design matrix X[,coef.d] does not have full rank.")
  mod1 <- mod1[,c(1,2,4)]

  rr1 <- suppressWarnings(initRandrot(Y = t(df1$feature1), X = mod1, coef.h = ncol(mod1), weights = t(df1$w)))

  edata.rot <- randrot(rr1)

  df2 <- df1
  df2$feature1 <- edata.rot[1,]

  me0.rot <- lmer(feature1 ~ 1 + (1|individual), data = df2, weights = w)

  expect_equal(ranef(me0), ranef(me0.rot), tolerance = 1e-5)
  expect_equal(fixef(me0), fixef(me0.rot), tolerance = 1e-5)


  })

---
title: "Random Rotation Package Introduction"
author: "Peter Hettegger"
date: "`r Sys.Date()`"
output:
  BiocStyle::pdf_document:
    toc: TRUE
    fig_width: 4.7
    fig_height: 4
vignette: >
  %\VignetteIndexEntry{Random Rotation Package Introduction}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
bibliography: ../inst/REFERENCES.bib
link-citations: true
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
options(digits = 4)
```


# Introduction

`randRotation` is an R package intended for generation of randomly rotated data to resample null distributions of linear model based dependent test statistics. See also [@Yekutieli1999] for resampling dependent test statistics. The main application is to resample test statistics on linear model coefficients following arbitrary batch effect correction methods, see also section [Quick start](#quick-start). The random rotation methodology is thereby applicable for linear models in combination with normally distributed data. Note that the resampling procedure is actually based on random orthogonal matrices, which is a broader class than random rotation matrices. Nevertheless, we adhere to the naming convention of [@Langsrud2005] designating this approach as random rotation methodology. The methodology used in this vignette is described in [@Hettegger2021].
Possible applications for resampling by rotation, that are outlined in this document, are: (i) linear models in combination with practically arbitrary (linear or non-linear) batch effect correction methods, section \@ref(BE-correction); (ii) generation of resampled datasets for evaluation of data analysis pipelines, section \@ref(unskewed); (iii) calculation of resampling based test statistics for calculating resampling based p-values and false discovery rates (FDRs), sections \@ref(unskewed) and \@ref(FDR); and (iv) batch effect correction with linear mixed models \@ref(mixed-mod).

Generally, the rotation approach provides a methodology for generating resampled data in the context of linear models and thus potentially has further conceivable areas of applications in high-dimensional data analysis with dependent variables. Nevertheless, we focus this document on the outlined range of issues in order to provide an intuitive and problem-centered introduction.

# Installation

Execute the following code to install package `randRotation`:

```{r, eval=FALSE}
if(!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("randRotation")
```


# Sample dataset {#dataset}

For subsequent analyses we create a hypothetical dataset with 3 batches, each containing 5 Control and 5 Cancer samples with 1000 features (genes). Note that the created dataset is pure noise and no artificial covariate effects are introduced. We thus expect uniformly distributed p-values for linear model coefficients.

```{r message=FALSE}
library(randRotation)
set.seed(0)
# Dataframe of phenotype data (sample information)
pdata <- data.frame(batch = as.factor(rep(1:3, c(10,10,10))),
                    phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 1000

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

xtabs(data = pdata)
```


# Quick start - linear models with batch effect correction {#quick-start}

A main application of the package is to resample null distributions of parameter estimates for linear models following batch effect correction. We first create our model matrix:

```{r}
mod1 <- model.matrix(~1+phenotype, pdata)
head(mod1)
```

We then initialise the random rotation object with `initBatchRandrot` and select the `phenotype` coefficient
as the null hypothesis coefficient:

```{r}
rr <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
```

Now we define the data analysis pipeline that should be run on the original dataset and on the rotated dataset.
Here we include as first step (I) our batch effect correction routine `ComBat` (`r Biocpkg("sva")` package) and as second step (II) we obtain the t-values for covariate `phenotype` from the linear model fit.

```{r}
statistic <- function(Y, batch, mod){
  # (I) Batch effect correction with "Combat" from the "sva" package
  Y <- sva::ComBat(dat = Y, batch = batch, mod = mod)
  
  # (II) Linear model fit
  fit1 <- limma::lmFit(Y, design = mod)
  fit1 <- limma::eBayes(fit1)
  abs(fit1$t[,2])
}
```

Note that larger values of the `statistic` function are considered as more significant
in the subsequently used `pFdr` function. We thus take the absolute values of the coefficients in order to calculate two-sided (two-tailed) p-values with `pFdr`. We emphasize that we highly recommend using scale independent statistics (pivotal quantities) as e.g. t-values instead of parameter estimates (as with `coef`), see also `?randRotation::pFdr`. The explicit function calls like `sva::ComBat` are required if parallel computing is used, see `?randRotation::rotateStat`.

The `rotateStat` function calculates `statistic` on the original (non-rotated) dataset and on
10 random rotations. `batch` and `mod` are provided as additional parameters to `statistic`.

```{r message=FALSE, results='hide'}
rs1 <- rotateStat(initialised.obj = rr, R = 10, statistic = statistic,
                   batch = pdata$batch, mod = mod1)
```

```{r}
rs1
```

Resampling based p-values are obtained with `pFdr`. As we use "pooling"
of the rotated statistics in `pFdr`, 10 random rotations are sufficient.

```{r}
p.vals <- pFdr(rs1)
hist(p.vals, col = "lightgreen");abline(h = 100, col = "blue", lty = 2)
qqunif(p.vals)
```

We see that, as expected, our p-values are approximately uniformly distributed.

**Hint:** The outlined procedure also works with `statistic` functions which
return multiple columns (`rotateStat` and `pFdr` handle functions returning
multiple columns adequately). So one could e.g. perform multiple batch effect
correction methods and calculate the statistics of interest for each correction
method. By doing this, one could subsequently evaluate the influence of
different batch effect correction methods on the statistic of interest.

**Additional info:** Below, the analysis pipeline is performed without rotation
for comparison with the previous analyses.
Following batch effect correction with `ComBat` (`r Biocpkg("sva")` package),
we obtain p-values from linear fit coefficients 
(using the `r Biocpkg("limma")` package) as follows:

```{r}
library(limma)
library(sva)

edata.combat <- ComBat(dat = edata, batch = pdata$batch, mod = mod1)
fit1 <- lmFit(edata.combat, mod1)
fit1 <- eBayes(fit1)

# P-values from t-statistics
p.vals.nonrot <- topTable(fit1, coef = 2, number = Inf, sort.by="none")$P.Value

hist(p.vals.nonrot, col = "lightgreen");abline(h = 100, col = "blue", lty = 2)
qqunif(p.vals.nonrot)
plot(p.vals, p.vals.nonrot, log = "xy", pch = 20)
abline(0,1, col = 4, lwd = 2)
```

We see that the p-values are non-uniformly distributed. See also section \@ref(skewed-null).

# Basic principle of random rotation methods {#basic-principle}

In the random rotation methodology, the observed data vectors (for each feature) are
rotated in way that the *determined* coefficients ($\boldsymbol{B_D}$ in @Langsrud2005)
stay constant when resampling under the null hypothesis $H_0: \boldsymbol{B_H = 0}$, see [@Langsrud2005].

The following example shows that the intercept coefficient of the *null model* does not change when rotation is performed under the null hypothesis:

```{r}
# Specification of the full model
mod1 <- model.matrix(~1+phenotype, pdata)

# We select "phenotype" as the coefficient associated with H0
# All other coefficients are considered as "determined" coefficients
rr <- initRandrot(Y = edata, X = mod1, coef.h = 2)

coefs <- function(Y, mod){
  t(coef(lm.fit(x = mod, y = t(Y))))
}

# Specification of the H0 model
mod0 <- model.matrix(~1, pdata)

coef01 <- coefs(edata, mod0)
coef02 <- coefs(randrot(rr), mod0)

head(cbind(coef01, coef02))

all.equal(coef01, coef02)
```

However, the coefficients of the *full model* do change (for this parametrisation) when rotation is performed under the null hypothesis:

```{r}
coef11 <- coefs(edata, mod1)
coef12 <- coefs(randrot(rr), mod1)

head(cbind(coef11, coef12))
```

This is in principle how resampling based tests are constructed.
Note that the change in both coefficients is due to parametrisation of the model. Compare e.g. the following
parametrisation, where the *determined* coefficient (Intercept) does not change:

```{r}
mod2 <- mod1
mod2[,2] <- mod2[,2] - 0.5

coef11 <- coefs(edata, mod2)
coef12 <- coefs(randrot(rr), mod2)

head(cbind(coef11, coef12))
```


# Batch effect correction with subsequent linear model analysis {#BE-correction}

In the following we outline the use of the `randRotation` package for linear model analysis following batch effect correction as a prototype application in current biomedical research. We highlight the problems faced when batch effect correction is separated from data analysis with linear models. Although data analysis procedures with combined batch effect correction and model inference should be preferred, the separation of batch effect correction from subsequent analysis is unavoidable for certain applications. In the following we use `ComBat` (`r Biocpkg("sva")` package) as a model of a "black box" batch effect correction procedure. Subsequent linear model analysis is done with the `r Biocpkg("limma")` package. We use `limma` and `ComBat` as model functions for demonstration, as these are frequently used in biomedical research. We want to emphasize that neither the described issues are specific to these functions, nor do we want to somehow defame these highly useful packages.

## Skewed null distribution of p values {#skewed-null}

Separating a (possibly non-linear) batch effect correction method from linear model analysis could practically lead to non-uniform (skewed) null distributions of p-values for testing linear model coefficients. The intuitive reason for this skew is that the batch effect correction method combines information of all samples to remove the batch effects. After removing the batch effects, the samples are thus no longer independent. For further information please refer to section [df estimation](#dfest) and to the [references](#references).

The following example demonstrates the influence of the batch effect correction on the distribution of p-values. We first load the `r Biocpkg("limma")` package and create the model matrix with the intercept term and the phenotype term.

```{r message=FALSE, results='hold'}
library(limma)

mod1 = model.matrix(~phenotype, pdata)
```

Remember that our [sample dataset](#dataset) is pure noise. Thus, without batch effect correction,
fitting a linear model with `limma` and testing the phenotype coefficient results in uniformly distributed p-values:

```{r}
# Linear model fit
fit0 <- lmFit(edata, mod1)
fit0 <- eBayes(fit0)

# P values for phenotype coefficient
p0 <- topTable(fit0, coef = 2, number = Inf, adjust.method = "none",
               sort.by = "none")$P.Value
hist(p0, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p0)
```


We now perform batch effect correction using `ComBat` (`r Biocpkg("sva")` package):
```{r}
library(sva)
edata.combat = ComBat(edata, batch = pdata$batch, mod = mod1)
```

Performing the model fit and testing the phenotype effect on this modified dataset results in a skewed p-value distribution:

```{r}
# Linear model fit
fit1 <- lmFit(edata.combat, mod1)
fit1 <- eBayes(fit1)

# P value for phenotype coefficient
p.combat <- topTable(fit1, coef = 2, number = Inf, adjust.method = "none",
                     sort.by = "none")$P.Value
hist(p.combat, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.combat)
```

The histogram and Q-Q plot clearly show that the null-distribution of p-values is skewed when linear model analysis is performed following batch effect correction in a data analysis pipeline of this type. This problem is known and described e.g. in [@Nygaard2015]. Note that the null-distribution is skewed although the experimental design is balanced.


## Unskewed p-values by random rotation {#unskewed}

In the following, we take the data analysis pipeline of the previous section and incorporate it into the
random rotation environment. The `initBatchRandrot` function initialises the random rotation
object with the design matrix of the linear model. We thereby specify the coefficients associated with
the null hypothesis $H_0$ (see also \@ref(basic-principle)) with `coef.h`. 
Additionally, the batch covariate is provided.

Note that the implementation with `initBatchRandrot` in principle implicitly assumes a block design of the correlation matrix and restricted roation matrix, see also \@ref{nonblock}.

```{r}
init1 <- initBatchRandrot(edata, mod1, coef.h = 2, batch = pdata$batch)
```

We now pack the data analysis pipeline of above into our statistic function, which is
called for the original (non-rotate) data and for all data rotations:

```{r}
statistic <- function(Y, batch, mod, coef){
  Y.tmp <- sva::ComBat(dat = Y, batch = batch, mod = mod)

  fit1 <- limma::lmFit(Y.tmp, mod)
  fit1 <- limma::eBayes(fit1)
  # The "abs" is needed for "pFdr" to calculate 2-tailed statistics
  abs(fit1$t[,coef])
}
```

Data rotation and calling the `statistic` function is performed with `rotateStat`.

```{r message=FALSE, results='hide'}
res1 <- rotateStat(initialised.obj = init1, R = 10, statistic = statistic,
                   batch = pdata$batch, mod = mod1, coef = 2)
```

As we use pooling of rotated statistics, `R = 10` resamples should be sufficient (see also \@ref(number-resamples)).
We now calculate rotation based p-values with `pFdr`:

```{r}
p.rot <- pFdr(res1)
head(p.rot)

hist(p.rot, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.rot)
```

We see that our rotated p-values are roughly uniformly distributed.


For illustration of the skewness of non-rotated p-values, we compare the non-rotated p-values `p.combat` (batch corrected),
the rotated p-values `p.rot` (batch corrected) and the p-values from linear model analysis without batch correction `p0`.

```{r}
plot(density(log(p.rot/p0)), col = "salmon", "Log p ratios",
     panel.first = abline(v=0, col = "grey"),
     xlim = range(log(c(p.rot/p0, p.combat/p0))))
lines(density(log(p.combat/p0)), col = "blue")
legend("topleft", legend = c("log(p.combat/p0)", "log(p.rot/p0)"),
       lty = 1, col = c("blue", "salmon"))
```

We see the skew of the non-rotated p-values towards lower values. This is also seen in another
illustration below:

```{r}
plot(p0, p.combat, log = "xy", pch = 20, col = "lightblue", ylab = "")
points(p0, p.rot, pch = 20, col = "salmon")
abline(0,1, lwd = 1.5, col = "black")
legend("topleft", legend = c("p.combat", "p.rot"), pch = 20,
       col = c("lightblue", "salmon"))
```

The non-rotated p-values are on average lower than the rotated p-values:

```{r}
plot(density(log(p.combat/p.rot)), col = "blue",
     main = "log(p.combat / p.rot )", panel.first = abline(v=0, col = "grey"))
```


## Resampling based FDR {#FDR}

Additionally to resampling based p-values, the method `pFdr` could also be
used for estimating resampling based false discovery rates [@Yekutieli1999].

```{r}
fdr.q  <- pFdr(res1, "fdr.q")
fdr.qu <- pFdr(res1, "fdr.qu")
fdr.BH <- pFdr(res1, "BH")

FDRs <- cbind(fdr.q, fdr.qu, fdr.BH)
ord1 <- order(res1$s0, decreasing = TRUE)

FDRs.sorted <- FDRs[ord1,]

matplot(FDRs.sorted, type = "l", lwd = 2)
legend("bottomright", legend = c("fdr.q", "fdr.qu", "BH"), lty = 1:5, lwd = 2,
       col = 1:6)

head(FDRs.sorted)

```

## Contrasts {#contrasts}

The random rotation methodology can also be applied for contrasts. We introduce
an artificial group effect between group 2 and group 3 for the first 100 features (we use that later in \@ref(number-resamples)).

```{r warning=FALSE}
edata[,] <- rnorm(length(edata))
group <- as.factor(rep(1:3, 10))

# add group effect for the first 100 features
group.effect <- rep(c(0,0,1), 10)
edata[1:100,] <- t(t(edata[1:100,]) + group.effect)

mod.groups <- model.matrix(~ group)

contrasts1 <- limma::makeContrasts("2vs3" = group2 - group3,
                                   levels = mod.groups)
contrasts1
```

Using `contrastModel` we transform our model matrix to a new model matrix (with
same dimensions as `mod.groups`) which includes the contrast as last coefficient.
Thereby, all contrasts are set as `coef.h` (in the attributes of `mod.cont`).

```{r}
mod.cont <- contrastModel(X = mod.groups, C = contrasts1)
```

The random rotation object is automatically initalised with the contrasts
set as `coef.h`:

```{r}
init1 <- initBatchRandrot(edata, mod.cont, batch = pdata$batch)
```

Similarly to above, we can now test our contrast in the batch effect adjusted
data using random rotations:

```{r message=FALSE, results='hide', warning=FALSE}
statistic <- function(Y, batch, mod, cont){
  Y.tmp <- sva::ComBat(dat = Y, batch = batch, mod = mod)

  fit1 <- limma::lmFit(Y.tmp, mod)
  
  fit1 <- limma::contrasts.fit(fit1, cont)
  fit1 <- limma::eBayes(fit1)
  
  # The "abs" is needed for "pFdr" to calculate 2-tailed statistics
  abs(fit1$t[,1])
}

res1 <- rotateStat(initialised.obj = init1, R = 20, statistic = statistic,
                   batch = pdata$batch, mod = mod.groups, cont = contrasts1)
```

We calculate the rotation based p-values with `pFdr`:

```{r}
p.rot <- pFdr(res1)
head(p.rot)

hist(p.rot, freq = FALSE, col = "lightgreen", breaks = seq(0,1,0.1))
abline(1,0, col = "blue", lty = 2)
qqunif(p.rot)
```


# How many rotations ? {#number-resamples}

The sufficient number of rotations `R` for simulating the null-distribution of our statistic of interest
depends on multiple factors and is different for each application. A possible guiding principle
for finding a sufficient number of resamples could be the following.

Increase the number of resamples `R` until:

* the rotation procedure provides an adequately smooth null-distribution of the statistic of interest.
* the results (e.g. the number of features with `fdr < 0.05`) and/or null-distribution do not change substantially if the rotation procedure is repeated with the same `R`.

Consequently, `R` must be increased if one needs high precision in the tail regions of the null distribution (so e.g. if `fdr < 0.01` is used instead of `fdr < 0.05`). Nevertheless, note that the ordering of the features does not change if `R` is increased.

Large `R` might be required if e.g. features are highly dependent. In this case, for a single rotation, the resulting values of our statistic are highly similar and thus only *small intervals of the null-distribution* are simulated.

The following figure shows the null distribution (`R = 20`) and the test values of the example given in \@ref(contrasts):

```{r}
plot(density(res1$s0), main = "", ylim = c(0,1), col = 2)
lines(density(res1$stats[[1]]), col = 1)
legend("topright", col = 1:2, lty = 1,
       legend = c("null-distribution by rotation", "test statistic"))
```

We repeat the rotation procedure with `R = 20`:

```{r message=FALSE, results='hide', warning=FALSE}
res2 <- rotateStat(initialised.obj = init1, R = 20, statistic = statistic,
                   batch = pdata$batch, mod = mod.groups, cont = contrasts1)

p.rot2 <- pFdr(res2)

plot(density(res2$s0), main = "", ylim = c(0,1), col = 2)
lines(density(res2$stats[[1]]), col = 1)
legend("topright", col = 1:2, lty = 1,
       legend = c("null-distribution by rotation", "test statistic"))
```

Comparing the p-values shows:

```{r}
plot(p.rot, p.rot2, pch = 19, log = "xy")
abline(0,1, col = "red")
```

Together, these plots suggest, that `R = 20` is sufficient for this dataset.

Note that with `pFdr(res1)`, we assumed that the marginal distributions of the statistics are exchangeable (see also `?randRotation::pFdr`) and thus pooling of the rotated statistics can be used. By pooling rotated statistics, the number of random rotations can be substantially reduced.

# Correlation matrices with non-block design {#nonblock}

Function `initBatchRandrot` implicitly assumes a block design of the sample correlation matrix and the restricted rotation matrix (see also `?randRotation::initBatchRandrot`). This means that correlations between samples are allowed within batches, but are zero between batches. Simply put, biological replicates or technical replicates (or any other cause of non-zero sample correlation) are contained within single batches and are not distributed to different batches. In this case, each batch has his own sample correlation matrix and correlation coefficients between batches are assumed to be zero. This assumption seems restrictive at first view, but is computationally efficient, as the random rotation can be performed for each batch independently. This is how `initBatchRandrot` is implemented. However, a general correlation matrix with non-block design (non-zero sample correlations between batches) can be initialised with `initRandrot`. Thus, `initBatchRandrot` simply provides a comfortable wrapper for sample correlation matrices with block design or for rotation of data with batch structure. For a correlation matrix of $I_{n \times n}$, `initRandrot` and `initBatchRandrot` are practically equivalent.


# Batch effect correction with linear mixed models {#mixed-mod}

## Sample dataset

We now assume to have a dataset of repeated measures. We assume to have taken
biopsies of 15 individuals. From each individual we have taken 1
biopsy of healthy control tissue and 1 biopsy of cancer tissue. This is
a possible application for mixed models with the covariate "individual" as
random effect. The hypothetic dataset was generated in 3 batches.

```{r}
pdata$individual <- sort(c(1:15, 1:15))
colnames(pdata)[2] <- "tissue"
pdata$tissue <- c("Control", "Cancer")
pdata
```

As sample dataset, we take random normally distributed data with a random
normally distributed individual effect (both with variance 1).

```{r}
edata[,] <- rnorm(length(edata))
for(i in seq(1,ncol(edata),2)){
  tmp1 <- rnorm(nrow(edata))
  edata[,i] <- edata[,i] + tmp1
  edata[,i+1] <- edata[,i+1] + tmp1
}
```

## Estimation of `cormat`

For random rotation of the dataset, we need an estimate of the correlation
matrix `cormat` between sample replicates (of course different approaches than
the following are possible for estimating `cormat`). As the data is not batch 
effect corrected, we estimate the correlation matrix for each batch separately
and then average over all features and batches.

```{r}
library(nlme)
df1 <- data.frame(pdata, d1 = edata[1,])
spl1 <- split(1:nrow(pdata), pdata$batch)

covs1 <- function(., df1, i){
  df1$d1 <- .

  me1 <- lme(d1 ~ tissue, data = df1[i,], random = ~1|individual)
  getVarCov(me1, type = "marginal")[[1]]
}

covs1 <- sapply(spl1,
                function(samps)rowMeans(apply(edata, 1, covs1, df1, samps)))
cov1 <- matrix(rowMeans(covs1), 2, 2)
cormat <- cov2cor(cov1)
cormat
```

As expected, the sample correlation is roughly 0.5, as the residual variance
and the `individual` variance are both 1 in our sample dataset.

## Random rotation

We can now initialise our random rotation object with `initBatchRandrot`and
perform random rotation of our statistic of interest with `rotateStat`. 
We choose the absolute value of the t-statistic of coefficient `tissue` as
statistic. We use the function `removeBatchEffect` from package `r Biocpkg("limma")`
for batch effect correction. Note that `removeBatchEffect` here is just a
placeholder for any "black box batch effect correction procedure".


```{r}
cormat <-  diag(5) %x% cormat
cormat <- list(cormat, cormat, cormat)

mod1 <- model.matrix(~1+tissue, pdata)
rr1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch,
                        cormat = cormat)

statistic <- function(Y, batch, mod, df1){
  # Batch effect correction
  Y <- limma::removeBatchEffect(Y, batch = batch, design = mod)
  
  apply(Y, 1, function(j){
    df1$d1 <- j
    me0 <- nlme::lme(d1 ~ 1, data = df1, random = ~1|individual, method = "ML")
    me1 <- nlme::lme(d1 ~ tissue, data = df1, random = ~1|individual, method = "ML")
    
    abs(coef(me1)[1,2] / (sqrt(vcov(me1)[2,2])))
  })
  
}

rs1 <- rotateStat(initialised.obj = rr1, R = 4, statistic = statistic, 
                  batch = pdata$batch, mod = mod1, df1 = df1, parallel = TRUE)

p1 <- pFdr(rs1)

hist(p1, freq = FALSE); abline(h = 1, lty = 2, lwd = 2, col = "blue")
qqunif(p1)
```

As expected, the p-value is roughly uniformly distributed.

# Session info

```{r}
sessionInfo()
```

# References {#references}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\docType{class}
\name{rotateStat-class}
\alias{rotateStat-class}
\title{Rotated object containing rotated and non-rotated statistics}
\description{
This list based class contains calculated statistics for the original data
(\code{s0}) and rotated data (\code{stats}). See also
\code{\link[randRotation:rotateStat]{rotateStat}}.
}
\section{Components}{

\describe{
  \item{\code{s0}}{Calculated statistics for original (non-rotated) data as returned by the \code{statistic} function (\code{\link[randRotation:rotateStat]{rotateStat}}).}
  \item{\code{stats}}{List of length \code{ncol.s} containing statistics on rotated data for each column returned by the \code{statistic} function.}
  \item{\code{ncol.s}}{Number of columns returned by the \code{statistic} function.}
  \item{\code{R}}{Number of resamples/rotations.}
}
}

\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{rotateStat}
\alias{rotateStat}
\title{Generate data rotations and calculate statistics on it}
\usage{
rotateStat(
  initialised.obj,
  R = 10,
  statistic,
  ...,
  parallel = FALSE,
  BPPARAM = BiocParallel::bpparam()
)
}
\arguments{
\item{initialised.obj}{An initialised random rotation object as returned by \code{\link[randRotation:initRandrot]{initRandrot}} and \code{\link[randRotation:initRandrot]{initBatchRandrot}}.}

\item{R}{The number of resamples/rotations. Single \code{numeric} larger than 1.}

\item{statistic}{A function which takes a data matrix (same dimensions as \code{Y} - see also \code{\link[randRotation:initRandrot]{initRandrot}}) as first argument and returns a statistic of interest. Any further arguments are passed to it with the \code{...} argument.
We highly recommend using pivotal quantities as \code{statistic} if possible (see also \code{Details} in \code{\link[randRotation:pFdr]{pFdr}}).
Note that \code{\link[randRotation:pFdr]{pFdr}} considers larger values of statistics as more significant, so one-tailed tests may require reversal of the sign and two-tailed tests may require taking absolute values, see \code{Examples}.
The results of \code{statistic} for each resample are finally combined with \code{as.matrix} and \code{cbind}, so ensure that \code{statistic} returns either a vector or a matrix.
Results with multiple columns are possible and handled adequately in subsequent functions (e.g. \code{\link[randRotation:pFdr]{pFdr}}). Note that \code{statistic} must not necessarily be of the same length as \code{nrow(Y)}, but can also be e.g. a summary statistic of genes (like in gene set testing).}

\item{...}{Further named arguments for \code{statistic} which are passed unchanged each time it is called.
Avoid partial matching to arguments of \code{rotateStat}. See also the \code{Examples}.}

\item{parallel}{\code{logical} if parallel computation should be performed, see details for use of parallel computing.}

\item{BPPARAM}{An optional \code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}} instance, see documentation of \code{BiocParallel} package of Bioconductor.}
}
\value{
An object of class \code{\link[randRotation:rotateStat-class]{rotateStat}}.
}
\description{
This function generates rotations of data and calculates the provided \code{statistic} on each rotation and the non-rotated (original) data.
This is the central function of the package.
}
\details{
The function takes an initialised randrot object
(\code{\link[randRotation:initRandrot]{initRandrot}}) and a function that
calculates a statistic on the data. The statistic function thereby takes the
a matrix \code{Y} as first argument. Any further arguments are passed to it
by \code{...}.

Together with \code{\link[randRotation:pFdr]{pFdr}}, this function implements
the \code{workflow} described in \insertCite{Hettegger2021}{randRotation}.

Be aware that only data is rotated (see also
\code{\link[randRotation:randrot]{randrot}}), so any additional information
including \code{weights}, \code{X} etc. need to be provided to
\code{statistic}. See also package vignette and \code{Examples}.

Parallel processing is implemented with the BiocParallel package of Bioconductor.
The default argument \code{\link[BiocParallel:register]{BiocParallel::bpparam()}} for \code{BPPARAM}
returns the registered default backend.
See package documentation for further information and usage options.
If \code{parallel = TRUE} the function calls in \code{statistic} need to be called explicitly
with package name and "::". So e.g. calling \code{lmFit} from the
\code{limma} package is done with \code{limma::lmFit(...)}, see also the
examples in the package vignette.
}
\examples{
#set.seed(0)

# Dataframe of phenotype data (sample information)
# We simulate 2 sample classes processed in 3 batches
pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
                   phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 100

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

mod1 <- model.matrix(~phenotype, pdata)

# Initialisation of the random rotation class
init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
init1

# Definition of the batch effect correction procedure with subsequent calculation
# of two-sided test statistics
statistic <- function(., batch, mod, coef){

  # The "capture.output" and "suppressMessages" simply suppress any output
  capture.output(suppressMessages(
    Y.tmp <- sva::ComBat(., batch = batch, mod)
  ))

  fit1 <- lm.fit(mod, t(Y.tmp))
  abs(coef(fit1)[coef,])
}

# We calculate test statistics for the second coefficient

res1 <- rotateStat(initialised.obj = init1,
                    R = 10,
                    statistic = statistic,
                    batch = pdata$batch, mod = mod1, coef = 2)

hist(pFdr(res1))
}
\references{
\insertAllCited{}
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{randpermut}
\alias{randpermut}
\title{Generate random permutation matrix for n samples}
\usage{
randpermut(n)
}
\arguments{
\item{n}{Number of samples}
}
\value{
A random permutation matrix of dimension \code{n x n}
}
\description{
Generate a random permutation matrix for \code{n} samples.
}
\details{
This methods generates an orthogonal matrix with only
  one entry in each row and column being \code{1}, all other entries being
  \code{0}.
}
\examples{
tmp1 <- randpermut(5)
t(tmp1) \%*\% tmp1
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{weights,initRandrot-method}
\alias{weights,initRandrot-method}
\alias{weights,initBatchRandrot-method}
\title{Extract model weights}
\usage{
\S4method{weights}{initRandrot}(object, ...)

\S4method{weights}{initBatchRandrot}(object, ...)
}
\arguments{
\item{object}{An object of class
\code{\link[randRotation:initRandrot-class]{initRandrot-class}},
\code{\link[randRotation:initRandrot-class]{initRandrotW-class}} or
\code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.}

\item{...}{Kept for compatibility with the default method, see
\code{?stats::\link[stats:weights]{weights}}.
For objects defined in package \link[randRotation:randRotation-package]{randRotation},
this argument is currently not needed.}
}
\value{
Weights extracted from the object \code{object}. \code{NULL} if no
weights were specified.
See \code{?stats::\link[stats:weights]{weights}} for the value returned by the default method.
}
\description{
\code{weights} is a generic function which extracts fitting weights from objects returned by modeling functions.
NOTE: This man page is for the weights S4 generic function defined in the \link[randRotation:randRotation-package]{randRotation} package.
}
\examples{
weights
showMethods("weights")
selectMethod("weights", "ANY")  # the default method

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\docType{class}
\name{initRandrot-class}
\alias{initRandrot-class}
\alias{initRandrotW-class}
\title{Initialised random rotation class}
\description{
List-based S4 class containing all information necessary to generate randomly
rotated data with the \code{\link[randRotation:randrot]{randrot}} method.
\code{initRandrot} and \code{initRandrotW} objects are created with the
\code{\link[randRotation:initRandrot]{initRandrot}} method.

\code{initRandrotW} is organised as its base class \code{initRandrot},
altough some components are changed or added.
}
\section{Components}{
 The following components are included as list elements:
\describe{
  \item{\code{X}}{Original (non-transformed) design matrix.}
  \item{\code{Xhe}, \code{Xhe.Y.w}, \code{Yd}}{Pre-multiplied matrix products needed for generation of rotated data (\code{\link[randRotation:randrot]{randrot}}).}
  \item{\code{coef.h}, \code{coef.d}}{Indices of \eqn{H_0}{H0} coefficients (\code{coef.h} or "hypothesis coefficients") and indices of all other coefficients (\code{coef.d} or "determined coefficients").}
  \item{\code{cormat}}{Correlation matrix, see \code{\link[randRotation:initRandrot]{initRandrot}}.}
  \item{\code{tcholC}}{Cholesky decomposition of cormat: \code{cormat = crossprod(tcholC)}.}
  \item{\code{rank}}{Rank of the qr decomposition of (transformed/whitened) \code{X}}
}


The following components are changed or added in \code{initRandrotW-class}
as compared to \code{initRandrot-class}:
\describe{
  \item{\code{decomp.list}}{List containing \code{Xd}, \code{Xhe} and rank of the transformed/whitened design matrix for each feature, see also \code{\link[randRotation:X_decomp]{X_decomp}}.}
  \item{\code{w}}{Numeric matrix with dimensions \code{features x samples} containing component wise square root of the weight matrix, see \code{\link[randRotation:initRandrot]{initRandrot}}.}
}
}

\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{show,initRandrot-method}
\alias{show,initRandrot-method}
\alias{show,initBatchRandrot-method}
\alias{show,rotateStat-method}
\title{Show an Object}
\usage{
\S4method{show}{initRandrot}(object)

\S4method{show}{initBatchRandrot}(object)

\S4method{show}{rotateStat}(object)
}
\arguments{
\item{object}{An object of class
\code{\link[randRotation:initRandrot-class]{initRandrot-class}},
\code{\link[randRotation:initRandrot-class]{initRandrotW-class}} or
\code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.}
}
\value{
\code{show} returns an invisible \code{NULL}.
}
\description{
Display the object by printing structured summary information.
}
\details{
The show method always displays the original design matrix
  (\code{X}), not the transformed (whitened) versions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\docType{package}
\name{randRotation-package}
\alias{randRotation}
\alias{randRotation-package}
\title{randRotation: Random Rotation Methods for High Dimensional Data with Batch Structure}
\description{
A collection of methods for performing random rotations on high-dimensional, normally distributed data (e.g. microarray or RNA-seq data) with batch structure. The random rotation approach allows exact testing of dependent test statistics with linear models following arbitrary batch effect correction methods.
}
\details{
Please refer to the package vignette for further details on usage and for
a "quick start". \code{\link[randRotation:rotateStat]{rotateStat}} is
the central function of the package. Methods are described in
\insertCite{Hettegger2021}{randRotation}.
}
\references{
\insertAllCited{}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/phettegger/randRotation}
  \item Report bugs at \url{https://github.com/phettegger/randRotation/issues}
}

}
\author{
\strong{Maintainer}: Peter Hettegger \email{p.hettegger@gmail.com} (\href{https://orcid.org/0000-0001-8557-588X}{ORCID})

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{pFdr}
\alias{pFdr}
\title{Calculate resampling based p-values and FDRs}
\usage{
pFdr(obj, method = "none", pooled = TRUE, na.rm = FALSE, beta = 0.05)
}
\arguments{
\item{obj}{A \code{rotateStat} object as returned by \code{\link[randRotation:rotateStat]{rotateStat}}.}

\item{method}{Can be either \code{"none"} (default), \code{"fdr.q"}, \code{"fdr.qu"} or any term that can be passed as \code{method} argument to \code{\link[stats:p.adjust]{stats::p.adjust}}, see \code{Details}. If \code{method = "none"}, resampling based
p-values without further adjustment are calculated.}

\item{pooled}{\code{logical}. \code{TRUE} (default) if marginal distributions are exchangeable for all features so that rotated stats can be pooled, see \code{Details}.}

\item{na.rm}{\code{logical}. \code{NA} values are ignored if set \code{TRUE}. \code{NA} values should be avoided and could e.g. be removed by imputation in original data or by removing features that contain \code{NA} values. Few \code{NA} values do not have a large effect, but many \code{NA} values can lead to wrong estimations of p-values and FDRs. We highly recommend avoiding \code{NA} values.}

\item{beta}{\code{numeric} between \code{0} and \code{1}. Corresponds to beta in \insertCite{Yekutieli1999}{randRotation}.}
}
\value{
A \code{numeric} matrix of corrected p-values or FDRs with dimension \code{dim(obj$s0)}.
}
\description{
This function calculates either (1) resampling based p-values with subsequent
p-value adjustment using \code{\link[stats:p.adjust]{stats::p.adjust}} or (2)
resampling based false-discovery-rates (FDRs) for rotated statistics from a
\code{\link[randRotation:rotateStat]{rotateStat}} object.
}
\details{
Larger values of obj$s0 are considered more significant when
  compared to the empirical distribution. E.g. for calculation of resampling
  based p-values (with \code{pooled = FALSE}) we in principle use
  \code{p.val <- (rowSums(obj$stats >= obj$s0)+1)/(ncol(obj$stats)+1)} according to
  \insertCite{Phipson2010}{randRotation}.

  \code{method = "fdr.q"} and \code{method = "fdr.qu"} are resampling based
  fdr estimates and can only be used with \code{pooled = TRUE}. \code{method
  = "fdr.q"} is the FDR local estimator and \code{method = "fdr.qu"} is the
  FDR upper limit, see \insertCite{Reiner2003,Yekutieli1999}{randRotation}.
  For all other \code{method} arguments resampling based p-values are
  calculated and passed to \code{\link[stats:p.adjust]{stats::p.adjust}} for
  p-value adjustment. So these methods provide resampling based p-values with
  (non-resampling based) p-value adjustment.
  \code{method = "fdr.q"} and \code{method = "fdr.qu"} were
  adapted from package \code{fdrame}
  \insertCite{Fdrame2019,Reiner2003}{randRotation}.

  When \code{pooled = TRUE},
  marginal distributions of the test statistics are considered exchangeable
  for all features. The resampling based p-values of each feature are then
  calculated from all rotated statistics (all features, all rotations). For
  these cases, if the number of features is reasonably large, usually only
  few resamples (argument \code{R} in
  \code{\link[randRotation:rotateStat]{rotateStat}}) are required.
  We want to emphasize that in order for the marginal distributions to be
  exchangeable, the statistics must be a pivotal quantity (i.e. it must be
  scale independent).
  Pivotal quantities are e.g. t values. Using e.g. linear models
  with \code{coef} as statistics is questionable if the different features
  are measured on different scales. The resampled coefficients then
  have different variances and \code{pooled = TRUE} is not applicable.
  We thus highly recommend using pivotal quantities as \code{statistics} in
  \code{\link[randRotation:rotateStat]{rotateStat}}
  if possible.

  When \code{pooled = FALSE} the resampling based p-values are calculcated
  for each feature separately. This is required if one expects the resampling
  based statistics to be distributed differently for individual features. For
  most common applications this should not be the case and the marginal
  distribution are exchangeable for all features, hence \code{pooled = TRUE}
  by default.

  If \code{method = "fdr.q"} or \code{method = "fdr.qu"} and
  \code{weights} were specified when initialising the random rotation
  object (see parameter \code{initialised.obj} in
  \code{\link[randRotation:rotateStat]{rotateStat}}), a warning is displayed.
  The correlation structure (dependence structure) of linear model
  coefficients between different features is not generally preserved if
  different weights are used for different features.
  Methods \code{fdr.q} and \code{fdr.qu} rely on preserved correlation
  structure of dependent statistics and thus should not be used if statistics
  based on model coefficients (e.g. t statistics of model coefficients) are
  used in combination with different weights.

  P-values and FDRs are calculated for each column of \code{obj$s0}
  separately.
}
\examples{
# See also '?rotateStat':

#set.seed(0)

# Dataframe of phenotype data (sample information)
# We simulate 2 sample classes processed in 3 batches
pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
                   phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 100

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

mod1 <- model.matrix(~phenotype, pdata)

# Initialisation of the random rotation class
init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
init1

# Definition of the batch effect correction procedure with subsequent calculation
# of two-sided test statistics
statistic <- function(., batch, mod, coef){

  # The "capture.output" and "suppressMessages" simply suppress any output
  capture.output(suppressMessages(
    Y.tmp <- sva::ComBat(., batch = batch, mod)
  ))

  fit1 <- lm.fit(mod, t(Y.tmp))
  abs(coef(fit1)[coef,])
}

# We calculate test statistics for the second coefficient

res1 <- rotateStat(initialised.obj = init1,
                    R = 10,
                    statistic = statistic,
                    batch = pdata$batch, mod = mod1, coef = 2)

hist(pFdr(res1))
}
\references{
\insertAllCited{}
}
\seealso{
\code{\link[randRotation:rotateStat]{rotateStat}}
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{randrot}
\alias{randrot}
\alias{randrot,initRandrot-method}
\alias{randrot,initRandrotW-method}
\alias{randrot,initBatchRandrot-method}
\title{Random rotation of initialised object}
\usage{
randrot(object, ...)

\S4method{randrot}{initRandrot}(object, ...)

\S4method{randrot}{initRandrotW}(object, ...)

\S4method{randrot}{initBatchRandrot}(object, ...)
}
\arguments{
\item{object}{An initialised object of class
\code{\link[randRotation:initRandrot-class]{initRandrot-class}} or
\code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.}

\item{...}{further arguments passed to
\code{\link[randRotation:randorth]{randorth}}}
}
\value{
\code{numeric} matrix of rotated data under the specified combined
  null hypothesis.
}
\description{
Perform random data rotation of a previously initialised object (see
\code{\link[randRotation:initRandrot]{initRandrot}}) associated with the
null hypothesis \eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0}.
}
\details{
This function generates a randomly rotated dataset from an initialised
randrot object (see \code{\link[randRotation:initRandrot]{initRandrot}}).
See also package vignette for application examples. Only the numerical matrix
of rotated data is returned, no design matrix, weights or other info is
return for efficiency purposes. Please consider that, if you e.g. use
\code{weights} or if you use
\code{\link[randRotation:rotateStat]{rotateStat}}, you may need to forward
the design matrix \code{X}, \code{weights} etc. to subsequent analyses. See
the example in \code{\link[randRotation:rotateStat]{rotateStat}}.

Details on the calculation of a rotated dataset are given in
\code{\link[randRotation:initRandrot]{initRandrot}},
\insertCite{Langsrud2005}{randRotation} and \insertCite{Hettegger2021}{randRotation}.
}
\examples{
# For further examples see '?rotateStat' and package vignette.

#set.seed(0)

# Dataframe of phenotype data (sample information)
# We simulate 2 sample classes processed in 3 batches
pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
                   phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 100

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

mod1 <- model.matrix(~phenotype, pdata)

# Initialisation of the random rotation class
init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2,
                            batch = pdata$batch)
init1

### Fit model to original data

fit.orig <- lm.fit(mod1, t(edata))
head(t(coef(fit.orig)))

### Fit model to rotated data

edata.rot <- randrot(init1)
fit.rot <- lm.fit(mod1, t(edata.rot))
head(t(coef(fit.rot)))


# Note that the coefficients stay equal if we regress only on the
# non-hypothesis coefficients

mod0 <- model.matrix(~1, pdata)
fit.orig0 <- lm.fit(mod0, t(edata))
fit.rot0  <- lm.fit(mod0, t(edata.rot))
head(t(coef(fit.orig0)))
head(t(coef(fit.rot0)))

}
\references{
\insertAllCited{}
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{dim,initRandrot-method}
\alias{dim,initRandrot-method}
\alias{dim,initBatchRandrot-method}
\title{Dimensions of an Object}
\usage{
\S4method{dim}{initRandrot}(x)

\S4method{dim}{initBatchRandrot}(x)
}
\arguments{
\item{x}{An object of class
\code{\link[randRotation:initRandrot-class]{initRandrot-class}} or
\code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot-class}}.}
}
\value{
Vector of length two with number of \code{features} and number of
  \code{samples}. See also
  \code{\link[randRotation:initRandrot]{initRandrot}}.
}
\description{
Retrieve the dimensions of an object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{.fdr.qu}
\alias{.fdr.qu}
\alias{.fdr.q}
\alias{.pFdr}
\title{Internal functions for p-value and FDR estimation}
\usage{
.fdr.qu(
  s0,
  stats,
  beta = 0.05,
  na.rm = FALSE,
  ref.vector = sort(s0, decreasing = TRUE, na.last = TRUE)
)

.fdr.q(
  s0,
  stats,
  beta = 0.05,
  na.rm = FALSE,
  ref.vector = sort(s0, decreasing = TRUE, na.last = TRUE)
)

.pFdr(s0, stats, method, pooled, na.rm, beta)
}
\arguments{
\item{s0}{\code{numeric} vector of original (non-rotated) statistics.}

\item{stats}{\code{numeric} matrix of rotated statistics.}

\item{beta}{\code{numeric} between 0 and 1. See \insertCite{Yekutieli1999}{randRotation}.}

\item{na.rm}{\code{logical}. Should missing values be removed ?}

\item{ref.vector}{Reference vector defining at which grid points of \code{s0}
and (\code{stats}) the FDRs are approximated. All other points are
approximated by spline interpolation. NAs are removed from ref.vector}

\item{method}{A p-value or FDR adjustment method, see
\code{\link[randRotation:pFdr]{pFdr}}.}

\item{pooled}{\code{logical}. \code{TRUE} if marginal distributions are
exchangeable for all features so that rotated stats can be pooled, see
\code{\link[randRotation:pFdr]{pFdr}}.}
}
\value{
\code{numeric} vector of (adjusted) p-value or FDR estimations for \code{s0}.
}
\description{
Internal functions for p-value and FDR estimation
}
\references{
\insertAllCited{}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{contrastModel}
\alias{contrastModel}
\title{Create transformed model matrix for contrast rotation}
\usage{
contrastModel(X, C, coef.h = seq_len(ncol(C)))
}
\arguments{
\item{X}{\code{(numeric)} model matrix with dimensions
\code{samples x coefficients}.}

\item{C}{\code{(numeric)} contrast matrix with dimensions
\code{coefficients x contrasts}. The contrast matrix must have full column rank.}

\item{coef.h}{column numbers of contrasts (in \code{C}) which should be set
as \code{coef.h} in the transformed model, see
\code{\link[randRotation:initRandrot]{initRandrot}}. All columns are set as
\code{coef.h} by default.}
}
\value{
A transformed model matrix with \code{coef.h} set as attribute.
}
\description{
This function takes a model matrix \code{X} and a contrast matrix \code{C}
and creates a transformed model matrix corresponding to a transformed set
of coefficients.
}
\details{
The last n coefficients of the transformed model matrix correspond to the n
contrasts. By default, all contrasts are set as \code{coef.h}.
See package vignette for examples of data rotations with contrasts.
}
\examples{

group <- c("A", "A", "B", "B")
X <- model.matrix(~0+group)
C <- cbind(contrast1 = c(1, -1))
X2 <- contrastModel(X, C)
}
\author{
Peter Hettegger
}

\name{randRotation-defunct}
\alias{df_estimate}
\title{Defunct functions in package \sQuote{randRotation}}
\description{These functions are defunct and no longer available.}

\details{
  Defunct functions are: \code{df_estimate}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{initRandrot}
\alias{initRandrot}
\alias{initBatchRandrot}
\alias{initBatchRandrot,list-method}
\alias{initRandrot,list-method}
\title{Initialisation of a random rotation Object}
\usage{
initRandrot(Y = NULL, X = NULL, coef.h = NULL, weights = NULL, cormat = NULL)

initBatchRandrot(
  Y = NULL,
  X = NULL,
  coef.h = NULL,
  batch = NULL,
  weights = NULL,
  cormat = NULL
)

\S4method{initBatchRandrot}{list}(
  Y = NULL,
  X = Y$design,
  coef.h = NULL,
  batch = NULL,
  weights = Y$weights,
  cormat = NULL
)

\S4method{initRandrot}{list}(
  Y = NULL,
  X = Y$design,
  coef.h = NULL,
  weights = Y$weights,
  cormat = NULL
)
}
\arguments{
\item{Y}{a data matrix with \code{features x samples} dimensions or a list
with elements \code{E}, \code{design} and \code{weights} (see
\code{Details}). Missing values (\code{\link[base:NA]{NA}}) are allowed but
e.g. lead to NAs for all samples of the respective features in the rotated
dataset and should thus be avoided. We highly recommend avoiding missing
values by e.g. replacing them by imputation or removing features containing
NAs.}

\item{X}{the design matrix of the experiment with \code{samples x
coefficients} dimensions. For \code{initBatchRandrot}, specify the design
matrix without the batch variable. A warning is generated if
\code{X[,coef.d]} does not have full rank, see Details.}

\item{coef.h}{single integer or vector of integers specifying the "hypothesis
coefficients" (\code{H0} coefficients). \code{coef.h} should correspond to
the last columns in \code{X} (see \code{Details}). If available,
\code{attr(X, "coef.h")} is used, see
\code{\link[randRotation:contrastModel]{contrastModel}}. By default, all
coefficients are set as \code{H0} coefficients. If \code{coef.h} is set
\code{-1}, no coefficient is set as \code{H0} coefficient.}

\item{weights}{numerical matrix of finite positive weights > 0 (as in
weighted least squares regression. Dimensions must be equal to dimensions
of \code{Y}.}

\item{cormat}{the sample correlation matrix with \code{samples x samples}
dimensions. Must be a real symmetric positive-definite square matrix. See
\code{Details} for usage in \code{initBatchRandrot}.}

\item{batch}{Batch covariate of the same length as \code{ncol(Y)}.}
}
\value{
An initialised
  \code{\link[randRotation:initRandrot-class]{initRandrot}},
  \code{\link[randRotation:initRandrot-class]{initRandrotW}} or
  \code{\link[randRotation:initBatchRandrot-class]{initBatchRandrot}}
  object.
}
\description{
Initialization of a linear model for subsequent generation of randomly
rotated data (\code{\link[randRotation:randrot]{randrot}}) associated with
the null hypothesis \eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0}.
Basics of rotation tests are found in \insertCite{Hettegger2021}{randRotation} and
\insertCite{Langsrud2005}{randRotation}.
}
\details{
This function performs basic initial checks and preparatory calculations for
random rotation data generation.
Nomenclature of variables is mainly as in
\insertCite{Langsrud2005}{randRotation} and \insertCite{Hettegger2021}{randRotation}. See also package vignette for
application examples.

\code{Y} can also be a list with elements \code{E}, \code{design} and
\code{weights}. \code{Y$E} is thereby used as \code{Y}, \code{Y$design} is
used as \code{X} and \code{Y$weights} is used as \code{weights}. By this, the
functions are compatible with results from e.g. \code{voom} (\code{limma}
package), see \code{Examples}.

\code{coef.h} specifies the model coefficients associated with the null
hypothesis ("hypothesis coefficients"). All other model coefficients are
considered as "determined coefficients" \code{coef.d}
\insertCite{Langsrud2005}{randRotation}. The design matrix is rearranged so
that \code{coef.h} correspond to the last columns of the design matrix and
\code{coef.d} correspond to the first columns of the design matrix. This
is necessary for adequate transformation of the combined null-hypothesis
\eqn{H_{0}: \beta_{coef.h} = 0}{H0: \beta_coef.h = 0} by QR decomposition.
If \code{X[,coef.d]} does not have full rank, a warning is generated and
\code{coef.d} is set to \code{coef.d <- seq_len(qr(X[,coef.d])$rank)}.


Weights must be finite positive \code{numerics} greater zero. This is
necessary for model (QR) decomposition and for back transformation of the
rotated data into the original variance structure, see also
\code{\link[randRotation:randrot]{randrot}}. Weights as estimated e.g. by
voom \insertCite{Law2014}{randRotation} are suitable and can be used without
further processing. Note that due to the whitening transformation (i.e. by
using the arguments \code{weights} and/or \code{cormat}) the rank of the
transformed (whitened) design matrix \code{X} could change (become smaller),
which could become dangerous for the fitting procedures. If you get errors
using \code{weights} and/or \code{cormat}, try the routine without using
\code{weights} and/or \code{cormat} to exclude this source of errors.


The following section provides a brief summary how rotations are calculated.
A more general introduction is given in
\insertCite{Langsrud2005}{randRotation}. For reasons of readability, we omit
writing \code{\%*\%} for matrix multiplication and write \code{*} for
transposed matrix. The rotation is done by multiplying the \code{features x
samples} data matrix \code{Y} with the transpose of the restricted random
rotation matrix \code{Rt}

\code{Rt = Xd Xd* + [Xh  Xe] R [Xh  Xe]*}

with \code{R} being a (reduced) random rotation matrix and \code{Xd},
\code{Xh} and \code{Xe} being columns of the full QR decomposition of the
design matrix \code{X}. \code{[Xd Xh Xe] = qr.Q(qr(X), complete = TRUE)},
where \code{Xd} correspond to columns \code{coef.d}, \code{Xh} to columns
\code{coef.h} and \code{Xe} to the remaining columns.

If \code{weights} and/or \code{cormat} are specified, each feature
\code{Y[i,]} and the design matrix \code{X} are whitening transformed before
rotation. The whitening matrix \code{T} is defined as \code{T = solve(C) w},
where \code{solve(C)} is the inverse Cholesky decompostion of the correlation
matrix (\code{cormat = CC*}) and \code{w} is a diagonal matrix of the square
roots of the sample weights for the according feature (\code{w =
diag(sqrt(weights[i,]}))).

The rotated data for one feature \code{y.r[i,]} is thus calculated as

\code{y.r[i,] = ( solve(T) Rt T (y[i,])* )*} and \code{[Xd Xh Xe] =
qr.Q(qr(TX), complete = TRUE)}

For \code{weights = NULL} and \code{cormat = NULL}, \code{T} is the identity
matrix.

Note that a separate QR decomposition is calculated for each feature if
\code{weights} are specified. The restricted random orthogonal matrix
\code{Rt} is calculated with the same reduced random orthogonal matrix \code{R}
for all features.

When using \code{initBatchRandrot}, \code{initRandrot} is called
  for each batch separately. When using \code{initBatchRandrot} with
  \code{cormat}, \code{cormat} needs to be a list of correlation matrices
  with one matrix for each batch. Note that this implicitly assumes a block
  design of the sample correlation matrix, where sample correlation
  coefficients between batches are zero. For a more general sample
  correlation matrix, allowing non-zero sample correlation coefficients
  between batches, see package vignette. Batches are split according to
  \code{split(seq_along(batch), batch)}.
}
\examples{
# For further examples see '?rotateStat' and package vignette.

# Example 1: Compatibility with limma::voom

\dontrun{
v <- voom(counts, design)
ir <- initRandrot(v)}

# Example 2:

#set.seed(0)

# Dataframe of phenotype data (sample information)
# We simulate 2 sample classes processed in 3 batches
pdata <- data.frame(batch = rep(1:3, c(10,10,10)),
                   phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 100

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

mod1 <- model.matrix(~phenotype, pdata)

# Initialisation of the random rotation class
init1 <- initBatchRandrot(Y = edata, X = mod1, coef.h = 2, batch = pdata$batch)
init1
# See '?rotateStat'
}
\references{
\insertAllCited{}
}
\seealso{
\code{\link[randRotation:randrot]{randrot}},
  \code{\link[randRotation:rotateStat]{rotateStat}}
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\docType{class}
\name{initBatchRandrot-class}
\alias{initBatchRandrot-class}
\title{Initialised random rotation batch object}
\description{
This class contains \code{initRandrot} or \code{initRandrotW} class
objects for each batch. See also descriptions in
\code{\link[randRotation:initRandrot]{initRandrot}} and
\code{\link[randRotation:initRandrot-class]{initRandrot-class}}.
}
\section{Components}{

\describe{
  \item{\code{batch.obj}}{List of \code{initRandrot} or \code{initRandrotW} class objects for each batch.}
  \item{\code{split.by}}{List of sample indices for each batch.}
}
}

\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{X_decomp}
\alias{X_decomp}
\title{Decomposition of the design matrix for random rotation generation}
\usage{
X_decomp(X = NULL, coef.d = seq_len(ncol(X) - 1))
}
\arguments{
\item{X}{Design matrix as generated by
\code{\link[stats:model.matrix]{model.matrix}}.}

\item{coef.d}{Non-\code{H0} coefficients.}
}
\value{
A \code{\link[base:list]{list}} object containing matrices \code{Xd},
  \code{Xhe} and rank of the qr decomposition.
}
\description{
Full QR decomposition of the design matrix \code{X}. No argument checks are
performed, see \code{Details}.
}
\details{
The design matrix \code{X} is QR decomposed into \code{X = Xq Xr}.
By performing a full QR decomposition, \code{Xq} is automatically extended to
a full basis. \code{Xq} is further split into \code{Xd} and \code{Xhe}, where
\code{Xd} corresponds to columns \code{coef.d} (non-\code{H0} or
non-Null-Hypothesis columns) and \code{Xhe} correspond to all other columns
(\code{H0} and error columns), see \code{\link[randRotation:initRandrot]{initRandrot}}.
No argument checks are performed for reasons
of performance as this function is called frequently by
\code{\link[randRotation:initRandrot]{initRandrot}} when weights are used.
See \insertCite{Hettegger2021}{randRotation} and \insertCite{Langsrud2005}{randRotation} for further details.
}
\examples{
design <- cbind(1, rep(0:1, 5))
X_decomp(design)
}
\references{
\insertAllCited{}
}
\author{
Peter Hettegger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{qqunif}
\alias{qqunif}
\title{Quantile-Quantile plot of data sample against uniform theoretical quantiles}
\usage{
qqunif(
  ps,
  log = "xy",
  pch = 20,
  xlab = "theoretical quantiles",
  ylab = "sample quantiles",
  plot.it = TRUE,
  ...
)
}
\arguments{
\item{ps}{\code{numeric} vector of values (e.g. p-values). Values must be
between 0 and 1. Values like \code{NA}, NaN, Inf etc. produce an error.}

\item{log}{\code{character} indicating whether axis should be plotted in log
scale. Either \code{""}, \code{"x"}, \code{"y"} or \code{"xy"}.}

\item{pch}{Point symbol, see \code{\link[graphics:par]{par}}.}

\item{xlab}{Label for the x axis.}

\item{ylab}{Label for the y axis.}

\item{plot.it}{\code{logical} whether the result should be plotted.}

\item{...}{Graphical parameters forwarded to \code{\link[stats:qqnorm]{qqplot}}}
}
\value{
A list of \code{x} and {y} coordinates, as in \code{\link[stats:qqnorm]{qqplot}}.
}
\description{
\code{qqunif} produces a QQ plot of the values in \code{ps} against the
theoretical quantiles of the uniform distribution.
}
\details{
This function can e.g. be used for comparing p-values against the uniform
distribution. The log scale of the x and y axes allow a closer look at low
p-values.

This function is a modified version of the examples in the
\code{\link[stats:qqnorm]{qqnorm}} documentation page.
}
\examples{
qqunif(runif(100))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{initRandrotW}
\alias{initRandrotW}
\title{Internal function}
\usage{
initRandrotW(Y, X, coef.h, coef.d, weights, cormat, cholCinv, tcholC)
}
\arguments{
\item{Y}{a data matrix with \code{features x samples} dimensions or a list
with elements \code{E}, \code{design} and \code{weights} (see
\code{Details}). Missing values (\code{\link[base:NA]{NA}}) are allowed but
e.g. lead to NAs for all samples of the respective features in the rotated
dataset and should thus be avoided. We highly recommend avoiding missing
values by e.g. replacing them by imputation or removing features containing
NAs.}

\item{X}{the design matrix of the experiment with \code{samples x
coefficients} dimensions. For \code{initBatchRandrot}, specify the design
matrix without the batch variable. A warning is generated if
\code{X[,coef.d]} does not have full rank, see Details.}

\item{coef.h}{single integer or vector of integers specifying the "hypothesis
coefficients" (\code{H0} coefficients). \code{coef.h} should correspond to
the last columns in \code{X} (see \code{Details}). If available,
\code{attr(X, "coef.h")} is used, see
\code{\link[randRotation:contrastModel]{contrastModel}}. By default, all
coefficients are set as \code{H0} coefficients. If \code{coef.h} is set
\code{-1}, no coefficient is set as \code{H0} coefficient.}

\item{coef.d}{Determined coefficients. These are all other coefficients that
are not hypothesis coefficients (see also
\code{\link[randRotation:initRandrot]{initRandrot}}).}

\item{weights}{numerical matrix of finite positive weights > 0 (as in
weighted least squares regression. Dimensions must be equal to dimensions
of \code{Y}.}

\item{cormat}{the sample correlation matrix with \code{samples x samples}
dimensions. Must be a real symmetric positive-definite square matrix. See
\code{Details} for usage in \code{initBatchRandrot}.}

\item{cholCinv}{Inverse of the Cholesky factorisation of \code{cormat}.}

\item{tcholC}{Transposed of the Cholesky factorisation of \code{cormat}.}
}
\value{
An initialised
  \code{\link[randRotation:initRandrot-class]{initRandrotW}} object.
}
\description{
Internal function
}
\examples{
# For further examples see '?rotateStat' and package vignette.

#set.seed(0)

# Dataframe of phenotype data (sample information)
# We simulate 2 sample classes processed in 3 batches
pdata <- data.frame(phenotype = rep(c("Control", "Cancer"), c(5,5)))
features <- 100

# Matrix with random gene expression data
edata <- matrix(rnorm(features * nrow(pdata)), features)
rownames(edata) <- paste("feature", 1:nrow(edata))

mod1 <- model.matrix(~phenotype, pdata)

### Simulate weights
weights <- matrix(rbeta(features * nrow(pdata), 2, 2)+0.1, features)

# Initialisation of the random rotation class
init1 <- initRandrot(Y = edata, X = mod1, coef.h = 2,
                        weights = weights)
init1
}
\author{
Peter Hettegger
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randRot.R
\name{randorth}
\alias{randorth}
\title{Random orthogonal matrix}
\usage{
randorth(n, type = c("orthonormal", "unitary"), I.matrix = FALSE)
}
\arguments{
\item{n}{\code{numeric} of length 1 defining the dimensions of the \code{n x n} square matrix.}

\item{type}{Either \code{"orthonormal"} or \code{"unitary"} defining whether a real orthonormal matrix or a complex unitary matrix should be returned.}

\item{I.matrix}{If \code{TRUE}, the identity matrix is returned.}
}
\value{
A random orthogonal matrix of dimension \code{n x n}.
}
\description{
Generation of a random orthogonal \code{n x n} matrix.
}
\details{
A random orthogonal matrix \code{R} is generated in order that \code{t(R)} (for \code{"orthonormal"}) or \code{Conj(t(R))} (for \code{"unitary"}) equals the inverse matrix of \code{R}.

This function was adapted from the pracma package (\code{\link[pracma:randortho]{pracma::randortho}}).

The random orthogonal matrices are distributed with Haar measure over
\code{O(n)}, where \code{O(n)} is the set of orthogonal matrices of order \code{n}.
The random orthogonal matrices are basically distributed "uniformly" in the
space of random orthogonal matrices of dimension \code{n x n}.
See also the \code{Examples} and \insertCite{Stewart1980a,Mezzadri2007}{randRotation}.
}
\examples{

# The following example shows the orthogonality of the random orthogonal matrix:
R1 <- randorth(4)
zapsmall(t(R1) \%*\% R1)

R1 <- randorth(4, "unitary")
zapsmall(Conj(t(R1)) \%*\% R1)

# The following example shows the distribution of 2-dimensional random orthogonal vectors
# on the unit circle.
tmp1 <- vapply(1:400, function(i)randorth(2)[,1], numeric(2))
plot(t(tmp1), xlab = "x", ylab = "y")

}
\references{
\insertAllCited{}
}
\author{
Peter Hettegger
}
